From f02d1d8062c49c52ea22564416a9a3f207061576 Mon Sep 17 00:00:00 2001
From: RSATom <RSATom@gmail.com>
Date: Sun, 22 May 2011 20:37:11 +0700
Subject: [PATCH] ActiveX/Mozilla FullScreen support

---
 projects/activex/axvlc.idl             |    5 +
 projects/activex/axvlc_rc.rc.in        |    6 +
 projects/activex/plugin.cpp            |   98 +++-
 projects/activex/plugin.h              |   18 +
 projects/activex/test.html             |   17 +-
 projects/activex/vlccontrol2.cpp       |   18 +-
 projects/activex/vlccontrol2.h         |    5 +
 projects/axVLCFullScreenWnd.h          |  917 ++++++++++++++++++++++++++++++++
 projects/defullscreen.bmp              |  Bin 0 -> 1334 bytes
 projects/mozilla/control/npolibvlc.cpp |   42 ++
 projects/mozilla/control/npolibvlc.h   |    1 +
 projects/mozilla/npvlc_rc.rc.in        |    7 +
 projects/mozilla/vlcplugin.cpp         |  107 ++++-
 projects/mozilla/vlcplugin.h           |   31 +-
 projects/mozilla/vlcshell.cpp          |   14 +
 projects/new_message.bmp               |  Bin 0 -> 1334 bytes
 projects/npVLCFullScreenWnd.h          |  899 +++++++++++++++++++++++++++++++
 projects/pause.bmp                     |  Bin 0 -> 1366 bytes
 projects/play.bmp                      |  Bin 0 -> 1366 bytes
 projects/volume-muted.bmp              |  Bin 0 -> 1334 bytes
 projects/volume.bmp                    |  Bin 0 -> 1334 bytes
 21 files changed, 2160 insertions(+), 25 deletions(-)
 create mode 100644 projects/axVLCFullScreenWnd.h
 create mode 100644 projects/defullscreen.bmp
 create mode 100644 projects/new_message.bmp
 create mode 100644 projects/npVLCFullScreenWnd.h
 create mode 100644 projects/pause.bmp
 create mode 100644 projects/play.bmp
 create mode 100644 projects/volume-muted.bmp
 create mode 100644 projects/volume.bmp

diff --git a/projects/activex/axvlc.idl b/projects/activex/axvlc.idl
index de7562d..0206458 100644
--- a/projects/activex/axvlc.idl
+++ b/projects/activex/axvlc.idl
@@ -644,6 +644,11 @@ library AXVLC
 
         [propget, helpstring("Returns the audio object.")]
         HRESULT video([out, retval] IVLCVideo** obj);
+        
+        [propget]
+        HRESULT NewMessageFlag([out, retval] VARIANT_BOOL* vYes);
+        [propput]
+        HRESULT NewMessageFlag([in] VARIANT_BOOL vYes);
     };
 
     [
diff --git a/projects/activex/axvlc_rc.rc.in b/projects/activex/axvlc_rc.rc.in
index f3cf3a8..bf5e8c0 100644
--- a/projects/activex/axvlc_rc.rc.in
+++ b/projects/activex/axvlc_rc.rc.in
@@ -25,6 +25,12 @@ BEGIN
 END
 
 2 BITMAP DISCARDABLE "inplace.bmp"
+3 BITMAP DISCARDABLE "..\\defullscreen.bmp"
+4 BITMAP DISCARDABLE "..\\play.bmp"
+5 BITMAP DISCARDABLE "..\\pause.bmp"
+6 BITMAP DISCARDABLE "..\\volume.bmp"
+7 BITMAP DISCARDABLE "..\\volume-muted.bmp"
+8 BITMAP DISCARDABLE "..\\new_message.bmp"
 
 1 TYPELIB "axvlc.tlb"
 
diff --git a/projects/activex/plugin.cpp b/projects/activex/plugin.cpp
index 1627e5e..5f5e714 100644
--- a/projects/activex/plugin.cpp
+++ b/projects/activex/plugin.cpp
@@ -52,6 +52,8 @@
 
 using namespace std;
 
+#include "../axVLCFullScreenWnd.h"
+
 ////////////////////////////////////////////////////////////////////////
 //class factory
 
@@ -75,7 +77,20 @@ static LRESULT CALLBACK VLCInPlaceClassWndProc(HWND hWnd, UINT uMsg, WPARAM wPar
                 EndPaint(hWnd, &ps);
             }
             return 0L;
-
+        case WM_SIZE:{
+            int new_client_width = LOWORD(lParam);
+            int new_client_height = HIWORD(lParam);
+            //first child will be resized to client area
+            HWND hChildWnd = GetWindow(hWnd, GW_CHILD);
+            if(hChildWnd){
+                MoveWindow(hChildWnd, 0, 0, new_client_width, new_client_height, FALSE);
+            }
+            return 0L;
+        }
+        case WM_LBUTTONDBLCLK:{
+            p_instance->toggleFullscreen();
+            return 0L;
+        }
         default:
             return DefWindowProc(hWnd, uMsg, wParam, lParam);
     }
@@ -122,6 +137,10 @@ VLCPluginClass::VLCPluginClass(LONG *p_class_ref, HINSTANCE hInstance, REFCLSID
         if( FAILED(OleCreatePictureIndirect(&pictDesc, IID_IPicture, TRUE, reinterpret_cast<LPVOID*>(&_inplace_picture))) )
             _inplace_picture = NULL;
     }
+
+    VLCHolderWnd::RegisterWndClassName(_hinstance);
+    VLCFullScreenWnd::RegisterWndClassName(_hinstance);
+
     AddRef();
 };
 
@@ -132,6 +151,9 @@ VLCPluginClass::~VLCPluginClass()
 
     if( NULL != _inplace_picture )
         _inplace_picture->Release();
+
+    VLCHolderWnd::UnRegisterWndClassName();
+    VLCFullScreenWnd::UnRegisterWndClassName();
 };
 
 STDMETHODIMP VLCPluginClass::QueryInterface(REFIID riid, void **ppv)
@@ -205,6 +227,8 @@ STDMETHODIMP VLCPluginClass::LockServer(BOOL fLock)
 
 VLCPlugin::VLCPlugin(VLCPluginClass *p_class, LPUNKNOWN pUnkOuter) :
     _inplacewnd(NULL),
+    _vlcholderwnd(NULL),
+    _vlcfswnd(NULL),
     _p_class(p_class),
     _i_ref(1UL),
     _p_libvlc(NULL),
@@ -212,7 +236,8 @@ VLCPlugin::VLCPlugin(VLCPluginClass *p_class, LPUNKNOWN pUnkOuter) :
     _p_mplayer(NULL),
     _i_midx(-1),
     _i_codepage(CP_ACP),
-    _b_usermode(TRUE)
+    _b_usermode(TRUE),
+    _b_new_messages_flag(false)
 {
     /*
     ** bump refcount to avoid recursive release from
@@ -694,16 +719,32 @@ HRESULT VLCPlugin::onActivateInPlace(LPMSG lpMesg, HWND hwndParent, LPCRECT lprc
             NULL
            );
 
-    if( NULL == _inplacewnd )
-        return E_FAIL;
+    if( _inplacewnd ){
+        SetWindowLongPtr(_inplacewnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this));
+        
+        /* change cliprect coordinates system relative to window bounding rect */
+        OffsetRect(&clipRect, -lprcPosRect->left, -lprcPosRect->top);
 
-    SetWindowLongPtr(_inplacewnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this));
-
-    /* change cliprect coordinates system relative to window bounding rect */
-    OffsetRect(&clipRect, -lprcPosRect->left, -lprcPosRect->top);
+        HRGN clipRgn = CreateRectRgnIndirect(&clipRect);
+        SetWindowRgn(_inplacewnd, clipRgn, TRUE);
 
-    HRGN clipRgn = CreateRectRgnIndirect(&clipRect);
-    SetWindowRgn(_inplacewnd, clipRgn, TRUE);
+        //create media window holder
+        _vlcholderwnd = VLCHolderWnd::CreateHolderWindow(this);
+        
+        //create Full Screen window
+        _vlcfswnd = VLCFullScreenWnd::CreateFSWindow(this);
+    }
+    
+    if( !_inplacewnd || !_vlcholderwnd || !_vlcfswnd){
+        if(_inplacewnd) DestroyWindow(_inplacewnd);
+        if(_vlcholderwnd) _vlcholderwnd->DestroyWindow();
+        if(_vlcfswnd) _vlcfswnd->DestroyWindow();
+        _inplacewnd=0;
+        _vlcholderwnd=0;
+        _vlcfswnd=0;
+        return E_FAIL;
+    }
+    
 
     if( _b_usermode )
     {
@@ -726,6 +767,32 @@ HRESULT VLCPlugin::onActivateInPlace(LPMSG lpMesg, HWND hwndParent, LPCRECT lprc
     return S_OK;
 };
 
+void VLCPlugin::toggleFullscreen()
+{
+    HWND hHolderParent = GetParent(getHolderWindow()->getHWND());
+    if(hHolderParent==getInPlaceWindow()){//now in windowed mode
+        SetParent(getHolderWindow()->getHWND(), _vlcfswnd->getHWND());
+        SetWindowPos(_vlcfswnd->getHWND(), HWND_TOPMOST, 0, 0, 
+                     GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), 0/** /SWP_NOZORDER/**/);
+
+        ShowWindow(_vlcfswnd->getHWND(), SW_SHOW);
+        ShowWindow(getInPlaceWindow(), SW_HIDE);
+    }
+    else if(hHolderParent==_vlcfswnd->getHWND()){//now in fullscreen mode
+        SetParent(getHolderWindow()->getHWND(), getInPlaceWindow());
+        
+        RECT InPlaceClientRect;
+        GetClientRect(getInPlaceWindow(), &InPlaceClientRect);
+        MoveWindow(getHolderWindow()->getHWND(), 0, 0, InPlaceClientRect.right, InPlaceClientRect.bottom, FALSE);
+        
+        ShowWindow(getInPlaceWindow(), SW_SHOW);
+        ShowWindow(_vlcfswnd->getHWND(), SW_HIDE);
+    }
+    else {
+        //and what it meen?
+    }
+}
+
 HRESULT VLCPlugin::onInPlaceDeactivate(void)
 {
     if( isPlaying() )
@@ -734,9 +801,15 @@ HRESULT VLCPlugin::onInPlaceDeactivate(void)
         fireOnStopEvent();
     }
 
+    _vlcfswnd->DestroyWindow();
+    _vlcfswnd = NULL;
+
+    _vlcholderwnd->DestroyWindow();
+    _vlcholderwnd = NULL;
+
     DestroyWindow(_inplacewnd);
     _inplacewnd = NULL;
-
+    
     return S_OK;
 };
 
@@ -1237,8 +1310,7 @@ bad_unlock:
 
 void VLCPlugin::set_player_window()
 {
-    // XXX FIXME no idea if this is correct or not
-    libvlc_media_player_set_hwnd(_p_mplayer,getInPlaceWindow());
+    libvlc_media_player_set_hwnd(_p_mplayer, _vlcholderwnd->getHWND());
 }
 
 void VLCPlugin::player_register_events()
diff --git a/projects/activex/plugin.h b/projects/activex/plugin.h
index 412bdce..027cd06 100644
--- a/projects/activex/plugin.h
+++ b/projects/activex/plugin.h
@@ -70,6 +70,8 @@ private:
     LPPICTURE   _inplace_picture;
 };
 
+class VLCHolderWnd;
+class VLCFullScreenWnd;
 class VLCPlugin : public IUnknown
 {
 
@@ -212,7 +214,11 @@ public:
 
     // control geometry within container
     RECT getPosRect(void) { return _posRect; };
+    inline VLCHolderWnd* getHolderWindow(void) const { return _vlcholderwnd; };
     inline HWND getInPlaceWindow(void) const { return _inplacewnd; };
+    void toggleFullscreen();    
+    
+
     BOOL isInPlaceActive(void);
 
     /*
@@ -355,7 +361,17 @@ private:
 
     // in place activated window (Plugin window)
     HWND _inplacewnd;
+    VLCHolderWnd* _vlcholderwnd;
+    VLCFullScreenWnd* _vlcfswnd;
+
+public:
+    VLCPluginClass* getVLCPluginClass(){return _p_class;};
+    void setNewMessageFlag(bool Yes)
+        {_b_new_messages_flag = Yes;};
+    bool getNewMessageFlag() const
+        {return _b_new_messages_flag;};
 
+private:
     VLCPluginClass* _p_class;
     ULONG _i_ref;
 
@@ -383,6 +399,8 @@ private:
     OLE_COLOR _i_backcolor;
     // indicates whether properties needs persisting
     BOOL _b_dirty;
+
+    bool _b_new_messages_flag;
 };
 
 #endif
diff --git a/projects/activex/test.html b/projects/activex/test.html
index 4d05ba6..b33d3f9 100644
--- a/projects/activex/test.html
+++ b/projects/activex/test.html
@@ -191,7 +191,7 @@ Insert Slider widget
         <OPTION value=9>Y</OPTION>
     </SELECT>
 </TD>
-</TR>
+</TR>
 <TR>
 <TD>Logo video filter:
     <INPUT type=button value="Enable" onClick='getVLC("vlc").video.logo.enable();'>
@@ -204,10 +204,11 @@ Insert Slider widget
         <OPTION value=4>Repeat</OPTION>
         <OPTION value=5>Delay</OPTION>
         <OPTION value=6>X</OPTION>
-        <OPTION value=7>Y</OPTION>
+        <OPTION value=7>Y</OPTION>
     </SELECT>
 </TD>
-</TR>
+</TR>
+
 <TR>
 <TD>
     <INPUT type=button id="telx" value="Teletext off" onClick='doToggleTeletext();'>
@@ -215,6 +216,12 @@ Insert Slider widget
     <INPUT size=4 value="100" id="telxPage" onClick='doTelxPage(document.getElementById("telxPage").value);'>
 </TD>
 </TR>
+<TR>
+<TD>
+    <INPUT type=button id="msg_y" value="Enable New Message Flag" onClick='getVLC("vlc").NewMessageFlag=true;'>
+    <INPUT type=button id="msg_n" value="Disable New Message Flag" onClick='getVLC("vlc").NewMessageFlag=false;'>
+</TD>
+</TR>
 </TABLE>
 <SCRIPT language="javascript">
 <!--
@@ -618,7 +625,7 @@ function onPlaying()
                 info.innerHTML = liveFeedText[liveFeedRoll++];
             }
         }
-    }
+    
 }
 
 function onPause()
@@ -665,7 +672,7 @@ function doMarqueeOption(option, value)
             vlc.video.marquee.y = val;
     }
 }
-
+
 function doLogoOption(option, value)
 {
     var vlc = getVLC("vlc");
diff --git a/projects/activex/vlccontrol2.cpp b/projects/activex/vlccontrol2.cpp
index 2940e4e..3c418c1 100644
--- a/projects/activex/vlccontrol2.cpp
+++ b/projects/activex/vlccontrol2.cpp
@@ -1098,7 +1098,8 @@ STDMETHODIMP VLCVideo::toggleFullscreen()
     HRESULT hr = getMD(&p_md);
     if( SUCCEEDED(hr) )
     {
-        libvlc_toggle_fullscreen(p_md);
+        _p_instance->toggleFullscreen();
+        //libvlc_toggle_fullscreen(p_md);
     }
     return hr;
 };
@@ -1495,3 +1496,18 @@ STDMETHODIMP VLCControl2::get_video(IVLCVideo** obj)
 {
     return object_get(obj,_p_vlcvideo);
 }
+
+STDMETHODIMP VLCControl2::get_NewMessageFlag(VARIANT_BOOL* vYes)
+{
+    if( NULL == vYes )
+        return E_POINTER;
+
+    (*vYes) = _p_instance->getNewMessageFlag()?VARIANT_TRUE:VARIANT_FALSE;
+    return S_OK;
+}
+
+STDMETHODIMP VLCControl2::put_NewMessageFlag(VARIANT_BOOL vYes)
+{
+    _p_instance->setNewMessageFlag(vYes!=VARIANT_FALSE);
+    return S_OK;
+}
diff --git a/projects/activex/vlccontrol2.h b/projects/activex/vlccontrol2.h
index 698331e..4a88c3d 100644
--- a/projects/activex/vlccontrol2.h
+++ b/projects/activex/vlccontrol2.h
@@ -295,6 +295,7 @@ class VLCVideo: public VLCInterface<VLCVideo,IVLCVideo>
 {
 public:
     VLCVideo(VLCPlugin *p): VLCInterface<VLCVideo,IVLCVideo>(p),
+        _p_instance(p),
         _p_vlcmarquee(new VLCMarquee(p)), _p_vlclogo(new VLCLogo(p)),
         _p_vlcdeint(new VLCDeinterlace(p)) { }
     virtual ~VLCVideo() {
@@ -324,6 +325,7 @@ public:
     STDMETHODIMP toggleTeletext();
 
 private:
+    VLCPlugin       *_p_instance;
     IVLCMarquee     *_p_vlcmarquee;
     IVLCLogo        *_p_vlclogo;
     IVLCDeinterlace *_p_vlcdeint;
@@ -387,6 +389,9 @@ public:
     STDMETHODIMP get_playlist(IVLCPlaylist**);
     STDMETHODIMP get_subtitle(IVLCSubtitle**);
     STDMETHODIMP get_video(IVLCVideo**);
+    
+    STDMETHODIMP get_NewMessageFlag(VARIANT_BOOL* vYes);
+    STDMETHODIMP put_NewMessageFlag(VARIANT_BOOL vYes);
 
 protected:
     HRESULT loadTypeInfo();
diff --git a/projects/axVLCFullScreenWnd.h b/projects/axVLCFullScreenWnd.h
new file mode 100644
index 0000000..781e6fa
--- /dev/null
+++ b/projects/axVLCFullScreenWnd.h
@@ -0,0 +1,917 @@
+extern HMODULE DllGetModule();
+inline libvlc_media_player_t* getMD(VLCPlugin* p_instance)
+{
+	libvlc_media_player_t *p_md;
+	HRESULT hr = p_instance->getMD(&p_md);
+	if( SUCCEEDED(hr) ){
+		return p_md;
+	}
+	return 0;
+}
+
+///////////////////////
+//VLCHolderWnd
+///////////////////////
+class VLCHolderWnd
+{
+public:
+	static void RegisterWndClassName(HINSTANCE hInstance);
+	static void UnRegisterWndClassName();
+	static VLCHolderWnd* CreateHolderWindow(VLCPlugin* p_instance);
+	void DestroyWindow()
+		{::DestroyWindow(_hWnd);};
+
+private:
+	static LPCTSTR getClassName(void)  { return TEXT("VLC ActiveX Media Window Holder Class"); };
+	static LRESULT CALLBACK VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+	static HINSTANCE _hinstance;
+    static ATOM _holder_wndclass_atom;
+
+private:
+	VLCHolderWnd(HWND hWnd, VLCPlugin* p_instance)
+		:_hWnd(hWnd), _p_instance(p_instance){};
+
+public:
+	HWND getHWND() const {return _hWnd;}
+
+private:
+	VLCPlugin* _p_instance;
+	HWND _hWnd;
+};
+
+/////////////////////////////////
+//VLCHolderWnd static members
+HINSTANCE VLCHolderWnd::_hinstance=0;
+ATOM VLCHolderWnd::_holder_wndclass_atom=0;
+
+
+void VLCHolderWnd::RegisterWndClassName(HINSTANCE hInstance)
+{
+	//save hInstance for future use
+	_hinstance=hInstance;
+
+    WNDCLASS wClass;
+
+    if( ! GetClassInfo(_hinstance, getClassName(), &wClass) )
+    {
+        wClass.style          = 0;//CS_NOCLOSE|CS_DBLCLKS;
+        wClass.lpfnWndProc    = VLCHolderClassWndProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getClassName();
+
+        _holder_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _holder_wndclass_atom = 0;
+    }
+}
+
+void VLCHolderWnd::UnRegisterWndClassName()
+{
+	if(0 != _holder_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_holder_wndclass_atom), _hinstance);
+		_holder_wndclass_atom=0;
+	}
+}
+
+VLCHolderWnd* VLCHolderWnd::CreateHolderWindow(VLCPlugin* p_instance)
+{
+	HWND hWnd = CreateWindow(getClassName(),
+	                         TEXT("Holder Window"),
+	                         WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_DISABLED,
+	                         0, 0, 0, 0,
+	                         p_instance->getInPlaceWindow(),
+	                         0,
+	                         VLCHolderWnd::_hinstance,
+	                         (LPVOID) p_instance
+	                         );
+
+	if(hWnd)
+		return reinterpret_cast<VLCHolderWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	
+	return 0;
+}
+
+LRESULT CALLBACK VLCHolderWnd::VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
+{
+	VLCHolderWnd* h_data = reinterpret_cast<VLCHolderWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = h_data ? h_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			p_instance = (VLCPlugin*)CreateStruct->lpCreateParams;
+
+			h_data = new VLCHolderWnd(hWnd, p_instance);
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(h_data));
+			
+			RECT ParentClientRect;
+			GetClientRect(CreateStruct->hwndParent, &ParentClientRect);
+			MoveWindow(hWnd, 0, 0, (ParentClientRect.right-ParentClientRect.left), (ParentClientRect.bottom-ParentClientRect.top), FALSE);
+			break;
+		}
+		case WM_NCDESTROY:
+			delete h_data;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, 0);
+			break;
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+};
+
+///////////////////////
+//VLCFullScreenWnd
+///////////////////////
+class VLCFullScreenWnd
+{
+public:
+	static void RegisterWndClassName(HINSTANCE hInstance);
+	static void UnRegisterWndClassName();
+	static VLCFullScreenWnd* CreateFSWindow(VLCPlugin* p_instance);
+	void DestroyWindow()
+		{::DestroyWindow(_hWnd);};
+
+
+private:
+	static LPCTSTR getClassName(void) { return TEXT("VLC ActiveX Fullscreen Class"); };
+	static LRESULT CALLBACK FSWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+	static LPCTSTR getControlsClassName(void) { return TEXT("VLC ActiveX Fullscreen Controls Class"); };
+	static LRESULT CALLBACK FSControlsWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+	static HINSTANCE _hinstance;
+    static ATOM _fullscreen_wndclass_atom;
+	static ATOM _fullscreen_controls_wndclass_atom;
+
+private:
+	VLCFullScreenWnd(HWND hWnd, VLCPlugin* p_instance)
+		:_hWnd(hWnd), _p_instance(p_instance),
+		 hControlsWnd(0), hToolTipWnd(0), hNewMessageBitmap(0), hFSButtonBitmap(0), hFSButton(0),
+		 hPauseBitmap(0), hPlayBitmap(0), hPlayPauseButton(0), hVideoPosScroll(0),  
+		 hMuteButton(0), hVolumeBitmap(0), hVolumeMutedBitmap(0),
+		 hVolumeSlider(0), Last_WM_MOUSEMOVE_lParam(0){};
+
+	~VLCFullScreenWnd();
+
+private:
+	void RegisterEvents();
+	void UnRegisterEvents();
+
+	void SetVideoPosScrollRangeByVideoLen();
+	void SyncVideoPosScrollPosWithVideoPos();
+	void SetVideoPos(float Pos); //0-start, 1-end
+	//void SetVideoPosByScrollPos(int CurScrollPos);
+	
+	void SyncVolumeSliderWithVLCVolume();
+	void SetVLCVolumeBySliderPos(int CurScrollPos);
+
+	void NeedShowControls();
+	void NeedHideControls();
+
+private:
+	void CreateToolTip();
+
+private:
+	LPARAM Last_WM_MOUSEMOVE_lParam;
+
+private:
+	VLCPlugin* _p_instance;
+	HWND hControlsWnd;
+	HWND hToolTipWnd;
+	
+	HICON hNewMessageBitmap;
+	HANDLE hFSButtonBitmap;
+	HWND hFSButton;
+	
+	HANDLE hPauseBitmap;
+	HANDLE hPlayBitmap; 
+	HWND hPlayPauseButton;
+
+	HWND hVideoPosScroll; 
+	
+	HANDLE hVolumeBitmap;
+	HANDLE hVolumeMutedBitmap;
+	HWND hMuteButton;
+	HWND hVolumeSlider;
+
+private:
+	void SetVideoPosScrollPosByVideoPos(int CurPos);
+	static bool handle_position_changed_event_enabled;
+	static void handle_position_changed_event(const libvlc_event_t* event, void *param);
+	//static void handle_time_changed_event(const libvlc_event_t* event, void *param);
+	static void handle_input_state_event(const libvlc_event_t* event, void *param);
+
+public:
+	HWND getHWND() const {return _hWnd;}
+private:
+	HWND _hWnd;
+	
+	int VideoPosShiftBits;
+};
+
+/////////////////////////////////
+//VLCFullScreenWnd static members
+HINSTANCE VLCFullScreenWnd::_hinstance=0;
+ATOM VLCFullScreenWnd::_fullscreen_wndclass_atom=0;
+ATOM VLCFullScreenWnd::_fullscreen_controls_wndclass_atom=0;
+
+bool VLCFullScreenWnd::handle_position_changed_event_enabled=true;
+void VLCFullScreenWnd::RegisterWndClassName(HINSTANCE hInstance)
+{
+	//save hInstance for future use
+	_hinstance=hInstance;
+
+    WNDCLASS wClass; 
+	
+	memset(&wClass, 0 , sizeof(wClass));
+	if( ! GetClassInfo(_hinstance,  getClassName(), &wClass) )
+    {
+        wClass.style          = CS_NOCLOSE|CS_DBLCLKS;
+        wClass.lpfnWndProc    = FSWndWindowProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getClassName();
+
+        _fullscreen_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _fullscreen_wndclass_atom = 0;
+    }
+	
+	memset(&wClass, 0 , sizeof(wClass));
+	if( ! GetClassInfo(_hinstance,  getControlsClassName(), &wClass) )
+    {
+        wClass.style          = CS_NOCLOSE;
+        wClass.lpfnWndProc    = FSControlsWndWindowProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getControlsClassName();
+
+        _fullscreen_controls_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _fullscreen_controls_wndclass_atom = 0;
+    }
+}
+void VLCFullScreenWnd::UnRegisterWndClassName()
+{
+	if(0 != _fullscreen_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_fullscreen_wndclass_atom), _hinstance);
+		_fullscreen_wndclass_atom=0;
+	}
+
+	if(0 != _fullscreen_controls_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_fullscreen_controls_wndclass_atom), _hinstance);
+		_fullscreen_controls_wndclass_atom=0;
+	}
+}
+
+LRESULT CALLBACK VLCFullScreenWnd::FSWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = fs_data ? fs_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			p_instance = (VLCPlugin*)CreateStruct->lpCreateParams;
+
+			fs_data = new VLCFullScreenWnd(hWnd, p_instance);
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(fs_data));
+			
+			fs_data->hControlsWnd = 
+				CreateWindow(fs_data->getControlsClassName(),
+						TEXT("VLC ActiveX Full Screen Controls Window"),
+						WS_VISIBLE|WS_CHILD|WS_CLIPSIBLINGS, 
+						0, 
+						0, 
+						0, 0,
+						hWnd,
+						0,
+						VLCFullScreenWnd::_hinstance,
+						(LPVOID) fs_data);
+			
+            break;
+		}
+		case WM_NCDESTROY:
+			delete fs_data;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, 0);
+			break;
+		case WM_MOUSEMOVE:{
+			if(fs_data->Last_WM_MOUSEMOVE_lParam!=lParam){
+				fs_data->Last_WM_MOUSEMOVE_lParam=lParam;
+				fs_data->NeedShowControls();
+			}
+			break;
+		}
+		case WM_SHOWWINDOW:{
+			if(FALSE==wParam){ //hidding
+				fs_data->UnRegisterEvents();	
+				break;
+			}
+			else{//showing
+				fs_data->RegisterEvents();	
+			}
+
+			fs_data->NeedShowControls();
+
+			//simulate lParam for WM_SIZE
+			RECT ClientRect;
+			GetClientRect(hWnd, &ClientRect);
+			lParam = MAKELPARAM(ClientRect.right, ClientRect.bottom);
+		}
+		case WM_SIZE:{
+			if(p_instance&&p_instance->getHolderWindow()&&GetParent(p_instance->getHolderWindow()->getHWND())==hWnd){
+				int new_client_width = LOWORD(lParam);
+				int new_client_height = HIWORD(lParam);
+				SetWindowPos(p_instance->getHolderWindow()->getHWND(), HWND_BOTTOM, 0, 0, new_client_width, new_client_height, SWP_NOACTIVATE|SWP_NOOWNERZORDER);
+			}
+			break;
+		}
+		case WM_LBUTTONDBLCLK:{
+			p_instance->toggleFullscreen();
+			break;
+		}
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+	return 0L;
+};
+
+#define ID_FS_SWITCH_FS 1
+#define ID_FS_PLAY_PAUSE 2
+#define ID_FS_VIDEO_POS_SCROLL 3
+#define ID_FS_MUTE 4
+#define ID_FS_VOLUME 5
+#define ID_FS_LABEL 5
+
+LRESULT CALLBACK VLCFullScreenWnd::FSControlsWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = fs_data ? fs_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			fs_data = (VLCFullScreenWnd*)CreateStruct->lpCreateParams;
+			p_instance = fs_data->_p_instance;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(fs_data));
+			
+			fs_data->hNewMessageBitmap = (HICON)
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(8), 
+			              IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+
+			const int ControlsHeigth = 21+2;
+			const int ButtonsWidth = ControlsHeigth;
+			const int ControlsSpace = 5;
+			const int ScrollVOffset = (ControlsHeigth-GetSystemMetrics(SM_CXHSCROLL))/2;
+
+			int HorizontalOffset=ControlsSpace;
+			int ControlWidth=ButtonsWidth;
+			fs_data->hFSButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("End Full Screen"), WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_FLAT, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_SWITCH_FS, 0, 0);
+			fs_data->hFSButtonBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(3), 
+			              IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hFSButtonBitmap);  
+			//SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hNewMessageBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			
+			ControlWidth=ButtonsWidth;
+			fs_data->hPlayPauseButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("Play/Pause"), WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_FLAT, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_PLAY_PAUSE, 0, 0);
+			fs_data->hPlayBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(4), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			fs_data->hPauseBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(5), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPauseBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+
+			ControlWidth=200;
+			int VideoPosControlHeight = 12;
+			fs_data->hVideoPosScroll = 
+				CreateWindow(PROGRESS_CLASS, TEXT("Video Position"), WS_CHILD|WS_DISABLED|WS_VISIBLE|SBS_HORZ|SBS_TOPALIGN|PBS_SMOOTH, 
+				             HorizontalOffset, ControlsSpace+(ControlsHeigth-VideoPosControlHeight)/2, ControlWidth, VideoPosControlHeight, hWnd, (HMENU)ID_FS_VIDEO_POS_SCROLL, 0, 0);
+			HMODULE hThModule = LoadLibrary(TEXT("UxTheme.dll"));
+			if(hThModule){
+				FARPROC proc = GetProcAddress(hThModule, "SetWindowTheme");
+				typedef HRESULT (WINAPI* SetWindowThemeProc)(HWND, LPCWSTR, LPCWSTR);
+				if(proc){
+					//SetWindowTheme(fs_data->hVideoPosScroll, L"", L"");
+					((SetWindowThemeProc)proc)(fs_data->hVideoPosScroll, L"", L"");
+				}
+				FreeLibrary(hThModule);
+			}
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			
+			ControlWidth=ButtonsWidth;
+			fs_data->hMuteButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("Mute"), WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_PUSHLIKE|BS_BITMAP, //BS_FLAT
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_MUTE, 0, 0);
+			fs_data->hVolumeBitmap =
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(6), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS|LR_SHARED);
+			fs_data->hVolumeMutedBitmap =
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(7), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS|LR_SHARED);
+			SendMessage(fs_data->hMuteButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hVolumeBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+
+			ControlWidth=100;
+			fs_data->hVolumeSlider = 
+				CreateWindow(TRACKBAR_CLASS, TEXT("Volume"), WS_CHILD|WS_VISIBLE|TBS_HORZ|TBS_BOTTOM|TBS_AUTOTICKS, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, 21, hWnd, (HMENU)ID_FS_VOLUME, 0, 0);
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			SendMessage(fs_data->hVolumeSlider, TBM_SETRANGE, FALSE, (LPARAM) MAKELONG (0, 100));
+			SendMessage(fs_data->hVolumeSlider, TBM_SETTICFREQ, (WPARAM) 10, 0);  
+			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE|SWP_NOOWNERZORDER);
+			
+			int ControlWndWidth = HorizontalOffset;
+			int ControlWndHeigth = ControlsSpace+ControlsHeigth+ControlsSpace;
+			SetWindowPos(hWnd, HWND_TOPMOST, (GetSystemMetrics(SM_CXSCREEN)-ControlWndWidth)/2, 0, 
+			             ControlWndWidth, ControlWndHeigth, SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_NOACTIVATE);
+			
+			//new message blinking timer
+			SetTimer(hWnd, 2, 500, NULL);
+			
+			fs_data->CreateToolTip();
+
+            break;
+		}
+		case WM_MOUSEMOVE:{
+			fs_data->Last_WM_MOUSEMOVE_lParam=lParam;
+			fs_data->NeedShowControls();//not allow close controll window while mouse within
+			break;
+		}
+		case WM_LBUTTONUP:{
+			POINT BtnUpPoint = {LOWORD(lParam), HIWORD(lParam)};
+			RECT VideoPosRect;
+			GetWindowRect(fs_data->hVideoPosScroll, &VideoPosRect);
+			ClientToScreen(hWnd, &BtnUpPoint);
+			if(PtInRect(&VideoPosRect, BtnUpPoint)){
+				fs_data->SetVideoPos(float(BtnUpPoint.x-VideoPosRect.left)/(VideoPosRect.right-VideoPosRect.left));
+			}
+			break;
+		}
+		case WM_TIMER:{
+			switch(wParam){
+				case 1:{
+					POINT MousePoint;
+					GetCursorPos(&MousePoint);
+					RECT ControlWndRect;
+					GetWindowRect(fs_data->hControlsWnd, &ControlWndRect);
+					if(PtInRect(&ControlWndRect, MousePoint)||GetCapture()==fs_data->hVolumeSlider){
+						fs_data->NeedShowControls();//not allow close control window while mouse within
+					}
+					else{
+						fs_data->NeedHideControls();
+					}
+					break;
+				}
+				case 2:{
+					LRESULT lResult = SendMessage(fs_data->hFSButton, BM_GETIMAGE, (WPARAM)IMAGE_BITMAP, 0);  
+					if((HANDLE)lResult == fs_data->hFSButtonBitmap){
+						if(p_instance->getNewMessageFlag()){
+							SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hNewMessageBitmap);  
+							fs_data->NeedShowControls();//not allow close controll window while new message exist
+						}
+					}
+					else{
+						SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hFSButtonBitmap);  
+					}
+
+					break;
+				}
+			}
+			break;
+		}
+		case WM_SETCURSOR:{
+			RECT VideoPosRect;
+			GetWindowRect(fs_data->hVideoPosScroll, &VideoPosRect);
+			DWORD dwMsgPos = GetMessagePos();
+			POINT MsgPosPoint = {LOWORD(dwMsgPos), HIWORD(dwMsgPos)};
+			if(PtInRect(&VideoPosRect, MsgPosPoint)){
+				SetCursor(LoadCursor(NULL, IDC_HAND));
+				return TRUE;
+			}
+			else{
+				return DefWindowProc(hWnd, uMsg, wParam, lParam);
+			}
+			break;
+		}
+		case WM_NCDESTROY:
+			break;
+		case WM_COMMAND:{
+			WORD NCode = HIWORD(wParam);
+			WORD Control = LOWORD(wParam);
+			switch(NCode){
+				case BN_CLICKED:{
+					switch(Control){
+						case ID_FS_SWITCH_FS:	
+							p_instance->toggleFullscreen();
+							break;
+						case ID_FS_PLAY_PAUSE:
+							if(p_instance->isPlaying()){
+								p_instance->playlist_pause();
+							}
+							else{
+								p_instance->playlist_play();
+							}
+							break;
+						case ID_FS_MUTE:{
+							IVLCControl2* vlccontrol2=0;
+							IVLCAudio* vlcaudio=0;
+							if(S_OK==p_instance->QueryInterface(IID_IVLCControl2, (void**)&vlccontrol2)&&
+							   S_OK==vlccontrol2->get_audio(&vlcaudio))
+							{
+								vlcaudio->put_mute(IsDlgButtonChecked(hWnd, ID_FS_MUTE)?VARIANT_TRUE:VARIANT_FALSE);
+								fs_data->SyncVolumeSliderWithVLCVolume();
+							}
+							if(vlcaudio) vlcaudio->Release();
+							if(vlccontrol2)	vlccontrol2->Release();
+							break;
+						}
+					}
+					break;
+				}
+			}
+			break;
+		}
+		case WM_HSCROLL: 
+		case WM_VSCROLL: {
+			libvlc_media_player_t* p_md = getMD(p_instance);
+			if( p_md ){
+				if(fs_data->hVolumeSlider==(HWND)lParam){
+					LRESULT SliderPos=SendMessage(fs_data->hVolumeSlider, (UINT) TBM_GETPOS, 0, 0);  
+					fs_data->SetVLCVolumeBySliderPos(SliderPos);
+				}
+			}
+			break;
+		}
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+	return 0L;
+};
+
+VLCFullScreenWnd* VLCFullScreenWnd::CreateFSWindow(VLCPlugin* p_instance)
+{
+	HWND hWnd = CreateWindow(getClassName(),
+				TEXT("VLC ActiveX Full Screen Window"),
+				WS_POPUP|WS_CLIPCHILDREN, 
+				0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
+				0,
+				0,
+				VLCFullScreenWnd::_hinstance,
+				(LPVOID) p_instance
+			   );
+	if(hWnd)
+		return reinterpret_cast<VLCFullScreenWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	
+	return 0;
+}
+
+/////////////////////////////////////
+//VLCFullScreenWnd members
+VLCFullScreenWnd::~VLCFullScreenWnd()
+{
+	if(hToolTipWnd){
+		::DestroyWindow(hToolTipWnd);
+		hToolTipWnd=0;
+	}
+
+	DestroyIcon(hNewMessageBitmap);
+	hNewMessageBitmap=0;
+	DeleteObject(hFSButtonBitmap); 
+	hFSButtonBitmap=0;
+
+	DeleteObject(hPauseBitmap); 
+	hPauseBitmap = 0;
+	DeleteObject(hPlayBitmap);
+	hPlayBitmap = 0;
+
+	DeleteObject(hVolumeBitmap);
+	hVolumeBitmap=0;
+	DeleteObject(hVolumeMutedBitmap);
+	hVolumeMutedBitmap=0;
+}
+
+void VLCFullScreenWnd::NeedShowControls()
+{
+	if(!IsWindowVisible(hControlsWnd)){
+		libvlc_media_player_t* p_md = getMD(_p_instance);
+		if( p_md ){
+			if(hVideoPosScroll){
+				SetVideoPosScrollRangeByVideoLen();
+				SyncVideoPosScrollPosWithVideoPos();
+			}
+			if(hVolumeSlider){
+				SyncVolumeSliderWithVLCVolume();
+			}
+			if(hPlayPauseButton){
+				SendMessage(hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(_p_instance->isPlaying()?hPauseBitmap:hPlayBitmap));  
+			}
+		}
+		ShowWindow(hControlsWnd, SW_SHOW);
+	}
+	//hide controls after 2 seconds
+	SetTimer(hControlsWnd, 1, 2*1000, NULL);
+}
+
+void VLCFullScreenWnd::NeedHideControls()
+{
+	KillTimer(hControlsWnd, 1);
+	ShowWindow(hControlsWnd, SW_HIDE);
+}
+
+void VLCFullScreenWnd::SyncVideoPosScrollPosWithVideoPos()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_time_t pos = libvlc_media_player_get_time(p_md);
+		SetVideoPosScrollPosByVideoPos(pos);
+	}
+}
+
+void VLCFullScreenWnd::SetVideoPosScrollRangeByVideoLen()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_time_t MaxLen = libvlc_media_player_get_length(p_md);
+		VideoPosShiftBits=0;
+		while(MaxLen>0xffff){
+			MaxLen >>= 1;
+			++VideoPosShiftBits;
+		};
+        SendMessage(hVideoPosScroll, (UINT)PBM_SETRANGE, 0, MAKELPARAM(0, MaxLen));
+	}
+}
+
+void VLCFullScreenWnd::SetVideoPosScrollPosByVideoPos(int CurScrollPos)
+{
+    SendMessage(hVideoPosScroll, (UINT)PBM_SETPOS, (WPARAM) (CurScrollPos >> VideoPosShiftBits), 0);
+}
+
+void VLCFullScreenWnd::SetVideoPos(float Pos) //0-start, 1-end
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_media_player_set_time(p_md, libvlc_media_player_get_length(p_md)*Pos);
+		SyncVideoPosScrollPosWithVideoPos();
+	}
+}
+
+void VLCFullScreenWnd::SyncVolumeSliderWithVLCVolume()
+{
+	IVLCControl2* vlccontrol2=0;
+	IVLCAudio* vlcaudio=0;
+	if(S_OK==_p_instance->QueryInterface(IID_IVLCControl2, (void**)&vlccontrol2)&&
+	   S_OK==vlccontrol2->get_audio(&vlcaudio))
+	{
+		LONG vol;
+		vlcaudio->get_volume(&vol);
+		const LRESULT SliderPos=SendMessage(hVolumeSlider, (UINT) TBM_GETPOS, 0, 0);  
+		if(SliderPos!=vol)
+			SendMessage(hVolumeSlider, (UINT) TBM_SETPOS, (WPARAM) TRUE, (LPARAM) vol);  
+
+		VARIANT_BOOL muted;
+		vlcaudio->get_mute(&muted);
+		int MuteButtonState = SendMessage(hMuteButton, (UINT) BM_GETCHECK, 0, 0);  
+		if((VARIANT_FALSE!=muted&&(BST_UNCHECKED==MuteButtonState))||(VARIANT_FALSE==muted&&(BST_CHECKED==MuteButtonState))){
+			SendMessage(hMuteButton, (UINT) BM_SETCHECK, (WPARAM)(VARIANT_FALSE!=muted?BST_CHECKED:BST_UNCHECKED), 0);
+		}
+		LRESULT lResult = SendMessage(hMuteButton, BM_GETIMAGE, (WPARAM)IMAGE_BITMAP, 0);  
+		if( (muted && ((HANDLE)lResult == hVolumeBitmap)) || (!muted&&((HANDLE)lResult == hVolumeMutedBitmap)) ){
+			SendMessage(hMuteButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(muted?hVolumeMutedBitmap:hVolumeBitmap));  
+		}
+	}
+	if(vlcaudio) vlcaudio->Release();
+	if(vlccontrol2)	vlccontrol2->Release();
+}
+
+void VLCFullScreenWnd::SetVLCVolumeBySliderPos(int CurPos)
+{
+	IVLCControl2* vlccontrol2=0;
+	IVLCAudio* vlcaudio=0;
+	if(S_OK==_p_instance->QueryInterface(IID_IVLCControl2, (void**)&vlccontrol2)&&
+	   S_OK==vlccontrol2->get_audio(&vlcaudio))
+	{
+		vlcaudio->put_volume(CurPos);
+		if(0==CurPos){
+			vlcaudio->put_mute(IsDlgButtonChecked(getHWND(), ID_FS_MUTE)?VARIANT_TRUE:VARIANT_FALSE);
+		}
+		SyncVolumeSliderWithVLCVolume();
+	}
+	if(vlcaudio) vlcaudio->Release();
+	if(vlccontrol2)	vlccontrol2->Release();
+}
+
+void VLCFullScreenWnd::CreateToolTip()
+{
+	hToolTipWnd = CreateWindowEx(WS_EX_TOPMOST,
+	        TOOLTIPS_CLASS,
+	        NULL,
+	        WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,		
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        this->getHWND(),
+	        NULL,
+	        _hinstance,
+	        NULL);
+
+	SetWindowPos(hToolTipWnd,
+	        HWND_TOPMOST,
+	        0, 0, 0, 0,
+	        SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
+
+
+	TOOLINFO ti;
+	ti.cbSize = sizeof(TOOLINFO);
+	ti.uFlags = TTF_SUBCLASS|TTF_IDISHWND;
+	ti.hwnd = this->getHWND();
+	ti.hinst = _hinstance;
+
+	TCHAR HintText[100];
+	RECT ActivateTTRect;
+
+	//end fullscreen button tooltip
+	GetWindowRect(this->hFSButton, &ActivateTTRect);
+	GetWindowText(this->hFSButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hFSButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+	
+	//play/pause button tooltip
+	GetWindowRect(this->hPlayPauseButton, &ActivateTTRect);
+	GetWindowText(this->hPlayPauseButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hPlayPauseButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+	
+	//mute button tooltip
+	GetWindowRect(this->hMuteButton, &ActivateTTRect);
+	GetWindowText(this->hMuteButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hMuteButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+}
+
+/////////////////////////////////////
+//VLCFullScreenWnd event handlers
+void VLCFullScreenWnd::handle_position_changed_event(const libvlc_event_t* event, void *param)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(param);
+	if(fs_data->handle_position_changed_event_enabled)
+		fs_data->SyncVideoPosScrollPosWithVideoPos();
+}
+
+void VLCFullScreenWnd::handle_input_state_event(const libvlc_event_t* event, void *param)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(param);
+    switch( event->type )
+    {
+        case libvlc_MediaPlayerNothingSpecial:
+            break;
+        case libvlc_MediaPlayerOpening:
+            break;
+        case libvlc_MediaPlayerBuffering:
+            break;
+        case libvlc_MediaPlayerPlaying:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPauseBitmap);  
+            break;
+        case libvlc_MediaPlayerPaused:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPlayBitmap);  
+            break;
+        case libvlc_MediaPlayerStopped:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPlayBitmap);  
+            break;
+        case libvlc_MediaPlayerForward:
+            break;
+        case libvlc_MediaPlayerBackward:
+            break;
+        case libvlc_MediaPlayerEndReached:
+            break;
+        case libvlc_MediaPlayerEncounteredError:
+            break;
+    }
+}
+
+void VLCFullScreenWnd::RegisterEvents()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_event_manager_t *eventManager = NULL;
+
+		eventManager = libvlc_media_player_event_manager(p_md);
+		if(eventManager) {
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerNothingSpecial,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerOpening,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerBuffering,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPlaying,
+								VLCFullScreenWnd::handle_input_state_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPaused,
+								VLCFullScreenWnd::handle_input_state_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerStopped,
+								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerForward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerBackward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerEndReached,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerEncounteredError,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerTimeChanged,
+//								VLCFullScreenWnd::handle_time_changed_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPositionChanged,
+			                    VLCFullScreenWnd::handle_position_changed_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerSeekableChanged,
+//								handle_seekable_changed_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerPausableChanged,
+//								handle_pausable_changed_event, this);
+
+		}
+	}
+}
+
+void VLCFullScreenWnd::UnRegisterEvents()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_event_manager_t *eventManager = NULL;
+
+		eventManager = libvlc_media_player_event_manager(p_md);
+		if(eventManager) {
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerNothingSpecial,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerOpening,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerBuffering,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+			
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPlaying,
+								handle_input_state_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPaused,
+								handle_input_state_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerStopped,
+								handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerForward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerBackward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerEndReached,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerEncounteredError,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerTimeChanged,
+//		                        VLCFullScreenWnd::handle_time_changed_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPositionChanged,
+								VLCFullScreenWnd::handle_position_changed_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerSeekableChanged,
+//		                        handle_seekable_changed_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerPausableChanged,
+//		                        handle_pausable_changed_event, this);
+		}
+	}
+}
+
diff --git a/projects/defullscreen.bmp b/projects/defullscreen.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..ec4ee66090d6416ad3e160fd9e8f7e37bfaa8b05
GIT binary patch
literal 1334
zcmZWoTPv(l7=Ff{*>hlPm_7E)H-|mW<B&sYD2KF>QzM0PD3Kf@g)0|GA`!Wk<Pb%2
zh+7x(54du=kSHbpVXx<%J@(l9sqg#NyVkef_j#Z7tY5)^0fK-Y@T-ya&!dAWw4e)p
z<jt{q3JMBvadCmJt}cv^kE5oh1~)f1cz%Ay@bECo%gZq^Fo3zaIW#sl;_dAXkB^Ti
zEiIKjGcz-Id3nLe$OxL6nov|!gvrTC1cO05JUpPPstSXHgIHW##QXa@o}Ql2+uMuR
z*H?^<jiIHbC4$udL*{e2TrinJJ+!s8p|7tGnx-K(HdgpYuG?%j=yZP@U0+|v>gp=I
zUaur)e^*ym@caF!tE<Dt#)jnU=;#pM6%`fI`@z8hSnK5E1o!v%(pPF~DvFDXF+Dvk
zy|d@*>uc$WoZ8#lF)=ZLg@pw)G&G1Ndc7XGxw**B&Ib3-&dwq#DhkQT$-*ZgApsVP
z1xBM$V(ueya&qMV$X+<l9A>i_B_$;cLB0-$16f&Fvc|mBhBb(P_cKmQOZ!-FZEZz&
zclSqqyWI|h!2qk(D*Cb>&yw@hn`e7|eh!bvBY842Gv)vE^mK_+Qc`esc82KaXsN%s
zxry4^T5z3u_xJZ>XlMwXot>z!ugBrxq5QwQyNjKj9r54V+8WBr$}lxGC0=Q6Zbl#w
zkp0xt?RE<n@~N(_#{B#|SeN;imX@Tq{QP{WAJ$U>^-4-g629^A@xqt6=<%>#^egWI
z{Xm`e_xCY6Itu1v{;jPo&|{UAmBQip_!yU$m*OY#$;-<_PfrgL6BC6e^YHAQPA4)l
zGDHjN%X24Ke|dQsKA%rwo*fZhr%!KhZ{-e<4|Spjg@uK}XJutY{7ruJ<K5jIj*gD7
zy}gao(^Ks2?a3XZ2g#pj!TTK6Q~BW&q<G}Zq8JfhltNK<K#Nh7-R>CeyMpqV_EoiG
zFns-p<9-lvno=Xyqt@fT5pkNj!6wEobrro{m!@3nFa!2bdQDwo&8K3g>YPyFPn)V|
rR8AsXnwn7B7?t{j7Oy54E9D5i-l!Q>Y*i;KU}8&TCo=xjtO|Yu{2b${

literal 0
HcmV?d00001

diff --git a/projects/mozilla/control/npolibvlc.cpp b/projects/mozilla/control/npolibvlc.cpp
index 2e6440e..9711365 100644
--- a/projects/mozilla/control/npolibvlc.cpp
+++ b/projects/mozilla/control/npolibvlc.cpp
@@ -101,6 +101,7 @@ const NPUTF8 * const LibvlcRootNPObject::propertyNames[] =
     "subtitle",
     "video",
     "VersionInfo",
+    "NewMessageFlag",
 };
 COUNTNAMES(LibvlcRootNPObject,propertyCount,propertyNames);
 
@@ -112,6 +113,7 @@ enum LibvlcRootNPObjectPropertyIds
     ID_root_subtitle,
     ID_root_video,
     ID_root_VersionInfo,
+    ID_root_NewMessageFlag,
 };
 
 RuntimeNPObject::InvokeResult
@@ -120,6 +122,8 @@ LibvlcRootNPObject::getProperty(int index, NPVariant &result)
     /* is plugin still running */
     if( isPluginRunning() )
     {
+        VlcPlugin* p_plugin = getPrivate<VlcPlugin>();
+
         switch( index )
         {
             case ID_root_audio:
@@ -144,6 +148,44 @@ LibvlcRootNPObject::getProperty(int index, NPVariant &result)
                 return INVOKERESULT_NO_ERROR;
             case ID_root_VersionInfo:
                 return invokeResultString(libvlc_get_version(),result);
+            case ID_root_NewMessageFlag:
+            {
+                bool val = p_plugin->getNewMessageFlag();
+                BOOLEAN_TO_NPVARIANT(val, result);
+                return INVOKERESULT_NO_ERROR;
+            }
+            default:
+                ;
+        }
+    }
+    return INVOKERESULT_GENERIC_ERROR;
+}
+RuntimeNPObject::InvokeResult
+LibvlcRootNPObject::setProperty(int index, const NPVariant &value)
+{
+    /* is plugin still running */
+    if( isPluginRunning() )
+    {
+        VlcPlugin* p_plugin = getPrivate<VlcPlugin>();
+
+        /*
+        libvlc_media_player_t *p_md = p_plugin->getMD();
+        if( !p_md )
+            RETURN_ON_ERROR;
+        */
+        switch( index )
+        {
+            case ID_root_NewMessageFlag:
+            {
+                if( ! NPVARIANT_IS_BOOLEAN(value) )
+                {
+                    return INVOKERESULT_INVALID_VALUE;
+                }
+
+                bool val = NPVARIANT_TO_BOOLEAN(value);
+                p_plugin->setNewMessageFlag(val);
+                return INVOKERESULT_NO_ERROR;
+            }
             default:
                 ;
         }
diff --git a/projects/mozilla/control/npolibvlc.h b/projects/mozilla/control/npolibvlc.h
index c6d8694..70477ee 100644
--- a/projects/mozilla/control/npolibvlc.h
+++ b/projects/mozilla/control/npolibvlc.h
@@ -46,6 +46,7 @@ protected:
     static const NPUTF8 * const propertyNames[];
 
     InvokeResult getProperty(int index, NPVariant &result);
+    InvokeResult setProperty(int index, const NPVariant &value);
 
     static const int methodCount;
     static const NPUTF8 * const methodNames[];
diff --git a/projects/mozilla/npvlc_rc.rc.in b/projects/mozilla/npvlc_rc.rc.in
index cb536e7..fdf66b5 100644
--- a/projects/mozilla/npvlc_rc.rc.in
+++ b/projects/mozilla/npvlc_rc.rc.in
@@ -41,3 +41,10 @@ BEGIN
         VALUE "Translation", 0x409, 1252
     END
 END
+
+3 BITMAP DISCARDABLE "..\\defullscreen.bmp"
+4 BITMAP DISCARDABLE "..\\play.bmp"
+5 BITMAP DISCARDABLE "..\\pause.bmp"
+6 BITMAP DISCARDABLE "..\\volume.bmp"
+7 BITMAP DISCARDABLE "..\\volume-muted.bmp"
+8 BITMAP DISCARDABLE "..\\new_message.bmp"
diff --git a/projects/mozilla/vlcplugin.cpp b/projects/mozilla/vlcplugin.cpp
index dea87e6..ef6d535 100644
--- a/projects/mozilla/vlcplugin.cpp
+++ b/projects/mozilla/vlcplugin.cpp
@@ -46,6 +46,35 @@
 #include <assert.h>
 #include <stdlib.h>
 
+
+#ifdef XP_WIN
+#include "..\npVLCFullScreenWnd.h"
+
+static HINSTANCE h_instance= 0;
+
+HMODULE DllGetModule()
+{
+    return h_instance;
+};
+
+extern "C" 
+BOOL WINAPI DllMain(HANDLE hModule, DWORD fdwReason, LPVOID lpReserved )
+{
+    switch( fdwReason )
+    {
+        case DLL_PROCESS_ATTACH:
+            h_instance = (HINSTANCE)hModule;
+            break;
+
+        default:
+            break;
+    }
+    return TRUE;
+};
+
+#endif
+
+
 /*****************************************************************************
  * utilitiy functions
  *****************************************************************************/
@@ -124,6 +153,9 @@ VlcPlugin::VlcPlugin( NPP instance, uint16_t mode ) :
     psz_baseURL(NULL)
 #if defined(XP_WIN)
     ,pf_wndproc(NULL)
+    ,_vlcholderwnd(0)
+    ,_vlcfswnd(0)
+    ,_b_new_messages_flag(false)
 #endif
 #if defined(XP_UNIX)
     ,i_width((unsigned)-1)
@@ -217,7 +249,7 @@ void VlcPlugin::event_callback(const libvlc_event_t* event, void *param)
     plugin->events.callback(event);
     NPN_PluginThreadAsyncCall(plugin->getBrowser(), eventAsync, plugin);
 #else
-#warning NPN_PluginThreadAsyncCall not implemented yet.
+//#warning NPN_PluginThreadAsyncCall not implemented yet.
     printf("No NPN_PluginThreadAsyncCall(), doing nothing.");
 #endif
 }
@@ -353,6 +385,8 @@ NPError VlcPlugin::init(int argc, char* const argn[], char* const argv[])
     }
     ppsz_argv[ppsz_argc++] = "--no-one-instance";
 
+    VLCHolderWnd::RegisterWndClassName(DllGetModule());
+    VLCFullScreenWnd::RegisterWndClassName(DllGetModule());
 #endif /* XP_MACOSX */
 
     /* common settings */
@@ -508,8 +542,26 @@ VlcPlugin::~VlcPlugin()
         libvlc_media_list_release( libvlc_media_list );
     if( libvlc_instance )
         libvlc_release(libvlc_instance);
+
+#ifdef XP_WIN
+    VLCHolderWnd::UnRegisterWndClassName();
+    VLCFullScreenWnd::UnRegisterWndClassName();
+#endif
 }
 
+void VlcPlugin::setWindow(const NPWindow &window)
+{ 
+    npwindow = window; 
+#ifdef XP_WIN
+    if(!_vlcholderwnd){
+        _vlcholderwnd = VLCHolderWnd::CreateHolderWindow(this);
+    }
+    if(!_vlcfswnd){
+        _vlcfswnd= VLCFullScreenWnd::CreateFSWindow(this);
+    }
+#endif
+};
+
 /*****************************************************************************
  * VlcPlugin playlist replacement methods
  *****************************************************************************/
@@ -524,7 +576,7 @@ void VlcPlugin::set_player_window()
 #endif
 #ifdef XP_WIN
     libvlc_media_player_set_hwnd(libvlc_media_player,
-                                 getWindow().window);
+                                 _vlcholderwnd->getHWND());///*getWindow().window*/
 #endif
 }
 
@@ -645,22 +697,73 @@ int VlcPlugin::playlist_count()
 
 void VlcPlugin::toggle_fullscreen()
 {
+#ifdef XP_WIN
+    if(!get_fullscreen()){//now in windowed mode
+        set_fullscreen(true);
+    }
+    else if(get_fullscreen()){//now in fullscreen mode
+        set_fullscreen(false);
+    }
+    else {
+        //and what it meen?
+    }
+#else
     if( playlist_isplaying() )
         libvlc_toggle_fullscreen(libvlc_media_player);
+#endif
 }
 
 void VlcPlugin::set_fullscreen( int yes )
 {
+#ifdef XP_WIN
+    if(yes){
+        if(!get_fullscreen()){//now in windowed mode
+            SetParent(getHolderWindow()->getHWND(), _vlcfswnd->getHWND());
+            SetWindowPos(_vlcfswnd->getHWND(), HWND_TOPMOST, 0, 0, 
+                         GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), 0/** /SWP_NOZORDER/**/);
+
+            ShowWindow(_vlcfswnd->getHWND(), SW_SHOW);
+            ShowWindow(((HWND)getWindow().window), SW_HIDE);
+        }
+    }
+    else{
+        if(get_fullscreen()){//now in fullscreen mode
+            SetParent(getHolderWindow()->getHWND(), ((HWND)getWindow().window));
+            
+            RECT InPlaceClientRect;
+            GetClientRect(((HWND)getWindow().window), &InPlaceClientRect);
+            MoveWindow(getHolderWindow()->getHWND(), 0, 0, InPlaceClientRect.right, InPlaceClientRect.bottom, FALSE);
+            
+            ShowWindow(((HWND)getWindow().window), SW_SHOW);
+            ShowWindow(_vlcfswnd->getHWND(), SW_HIDE);
+        }
+    }
+#else
     if( playlist_isplaying() )
         libvlc_set_fullscreen(libvlc_media_player,yes);
+#endif
 }
 
 int  VlcPlugin::get_fullscreen()
 {
+#ifdef XP_WIN
+    HWND hHolderParent = GetParent(getHolderWindow()->getHWND());
+    if(hHolderParent==((HWND)getWindow().window)){//now in windowed mode
+        return false;
+    }
+    else if(hHolderParent==_vlcfswnd->getHWND()){//now in fullscreen mode
+        return true;
+    }
+    else {
+        //and what it meen?
+        return false;
+    }
+#else
     int r = 0;
     if( playlist_isplaying() )
         r = libvlc_get_fullscreen(libvlc_media_player);
     return r;
+#endif
 }
 
 bool  VlcPlugin::player_has_vout()
diff --git a/projects/mozilla/vlcplugin.h b/projects/mozilla/vlcplugin.h
index 2ec8e57..d678fff 100644
--- a/projects/mozilla/vlcplugin.h
+++ b/projects/mozilla/vlcplugin.h
@@ -182,7 +182,11 @@ private:
     void unask_for_event(event_t e);
 };
 
-
+#ifdef XP_WIN
+class VLCHolderWnd;
+class VLCFullScreenWnd;
+HMODULE DllGetModule();
+#endif
 class VlcPlugin
 {
 public:
@@ -200,7 +204,7 @@ public:
     {
         if( !libvlc_media_player )
         {
-             libvlc_printerr("no mediaplayer");
+             //libvlc_printerr("no mediaplayer");
         }
         return libvlc_media_player;
     }
@@ -209,8 +213,8 @@ public:
     char*               getAbsoluteURL(const char *url);
     NPWindow&           getWindow()
                             { return npwindow; };
-    void                setWindow(const NPWindow &window)
-                            { npwindow = window; };
+    void                setWindow(const NPWindow &window);
+                            //{ npwindow = window; };
 
     NPClass*            getScriptClass()
                             { return p_scriptClass; };
@@ -333,7 +337,26 @@ private:
     NPWindow  npwindow;
 #if defined(XP_WIN)
     WNDPROC   pf_wndproc;
+    VLCHolderWnd* _vlcholderwnd;
+    VLCFullScreenWnd* _vlcfswnd;
+    
+    bool _b_new_messages_flag;
+
+public:
+    inline HWND getInPlaceWindow(void) 
+        { return (HWND)(getWindow().window); };
+    inline VLCHolderWnd* getHolderWindow() const
+        {return _vlcholderwnd;}
+    inline VLCFullScreenWnd* getFSWindow() const
+        {return _vlcfswnd;}
+    void setNewMessageFlag(bool Yes)
+        {_b_new_messages_flag = Yes;};
+    bool getNewMessageFlag() const
+        {return _b_new_messages_flag;};
+private:
+
 #endif
+
 #if defined(XP_UNIX)
     unsigned int     i_width, i_height;
     unsigned int     i_tb_width, i_tb_height;
diff --git a/projects/mozilla/vlcshell.cpp b/projects/mozilla/vlcshell.cpp
index 883205b..9a3caa7 100644
--- a/projects/mozilla/vlcshell.cpp
+++ b/projects/mozilla/vlcshell.cpp
@@ -753,6 +753,20 @@ static LRESULT CALLBACK Manage( HWND p_hwnd, UINT i_msg, WPARAM wpar, LPARAM lpa
             EndPaint( p_hwnd, &paintstruct );
             return 0L;
         }
+        case WM_SIZE:{
+            int new_client_width = LOWORD(lpar);
+            int new_client_height = HIWORD(lpar);
+            //first child will be resized to client area
+            HWND hChildWnd = GetWindow(p_hwnd, GW_CHILD);
+            if(hChildWnd){
+                MoveWindow(hChildWnd, 0, 0, new_client_width, new_client_height, FALSE);
+            }
+            return 0L;
+        }
+        case WM_LBUTTONDBLCLK:{
+            p_plugin->toggle_fullscreen();
+            return 0L;
+        }
         default:
             /* delegate to default handler */
             return CallWindowProc( p_plugin->getWindowProc(), p_hwnd,
diff --git a/projects/new_message.bmp b/projects/new_message.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..62d6fe502cfc7bafe2ef576fc8946567cd7111b0
GIT binary patch
literal 1334
zcmajdJ&xNz42EGYkStv02&{yhU~3|M?!Xhcb<3l$2=)pp#X4t5!6R(tCWZ6Lv}0hi
zKt_7>X-2;z@!R*8&vI=qpG3a0_vPkE4s+mX;@@qEuu8-P+o~GBO5T3Him1WCiJB<1
zhzS(zm?MxVw1^87209){6#DjDB@K>1qR=AjN-7MFK%&qhgp|VI2qX$E!YZvWI0A`6
ziwUnOihXee5`~_rsgedqAW`U<wkc_F1QLawPvS}%9Dzik=W~UU21g)K==qeXq`?tL
z6nZ{$DQR#75{1700&67=jzFT&63jnDvCrJGFNs1+s6b(G1QLaw-)2f09Dzik=a;&Y
z21g)K==t3|B*NebBnmyHkV+aHfkdIFOiD?EBakTcwS=OTG&ll@LQ66K5{1DLNbE~b
zX{nM1M<7w?DLYfr;0PoNJtgT%8XSQ{p{HC!NrNMhDD;$aDrs;85`~^JFC`6*K+4<i
zi~Qic;C>>P>nfMaz6X|lh|TjyZCT!pp56^C+hgFkEX!%zPQ;PRj_dZftqd&NcD}W3
wziK(G$6H$u(_ioH+CM+eKkvuShx_@5>ECZha{RbH`up>q_xHKAz5Ac`2Th8c&Hw-a

literal 0
HcmV?d00001

diff --git a/projects/npVLCFullScreenWnd.h b/projects/npVLCFullScreenWnd.h
new file mode 100644
index 0000000..1d2b894
--- /dev/null
+++ b/projects/npVLCFullScreenWnd.h
@@ -0,0 +1,899 @@
+#include <CommCtrl.h>
+#include <Uxtheme.h>
+
+typedef VlcPlugin VLCPlugin;
+
+inline libvlc_media_player_t* getMD(VLCPlugin* p_instance)
+{
+	return p_instance->getMD();
+}
+
+///////////////////////
+//VLCHolderWnd
+///////////////////////
+class VLCHolderWnd
+{
+public:
+	static void RegisterWndClassName(HINSTANCE hInstance);
+	static void UnRegisterWndClassName();
+	static VLCHolderWnd* CreateHolderWindow(VLCPlugin* p_instance);
+	void DestroyWindow()
+		{::DestroyWindow(_hWnd);};
+
+private:
+	static LPCTSTR getClassName(void)  { return TEXT("VLC ActiveX Media Window Holder Class"); };
+	static LRESULT CALLBACK VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+	static HINSTANCE _hinstance;
+    static ATOM _holder_wndclass_atom;
+
+private:
+	VLCHolderWnd(HWND hWnd, VLCPlugin* p_instance)
+		:_hWnd(hWnd), _p_instance(p_instance){};
+
+public:
+	HWND getHWND() const {return _hWnd;}
+
+private:
+	VLCPlugin* _p_instance;
+	HWND _hWnd;
+};
+
+/////////////////////////////////
+//VLCHolderWnd static members
+HINSTANCE VLCHolderWnd::_hinstance=0;
+ATOM VLCHolderWnd::_holder_wndclass_atom=0;
+
+
+void VLCHolderWnd::RegisterWndClassName(HINSTANCE hInstance)
+{
+	//save hInstance for future use
+	_hinstance=hInstance;
+
+    WNDCLASS wClass;
+
+    if( ! GetClassInfo(_hinstance, getClassName(), &wClass) )
+    {
+        wClass.style          = 0;//CS_NOCLOSE|CS_DBLCLKS;
+        wClass.lpfnWndProc    = VLCHolderClassWndProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getClassName();
+
+        _holder_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _holder_wndclass_atom = 0;
+    }
+}
+
+void VLCHolderWnd::UnRegisterWndClassName()
+{
+	if(0 != _holder_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_holder_wndclass_atom), _hinstance);
+		_holder_wndclass_atom=0;
+	}
+}
+
+VLCHolderWnd* VLCHolderWnd::CreateHolderWindow(VLCPlugin* p_instance)
+{
+	HWND hWnd = CreateWindow(getClassName(),
+	                         TEXT("Holder Window"),
+	                         WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_DISABLED,
+	                         0, 0, 0, 0,
+	                         p_instance->getInPlaceWindow(),
+	                         0,
+	                         VLCHolderWnd::_hinstance,
+	                         (LPVOID) p_instance
+	                         );
+
+	if(hWnd)
+		return reinterpret_cast<VLCHolderWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	
+	return 0;
+}
+
+LRESULT CALLBACK VLCHolderWnd::VLCHolderClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
+{
+	VLCHolderWnd* h_data = reinterpret_cast<VLCHolderWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = h_data ? h_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			p_instance = (VLCPlugin*)CreateStruct->lpCreateParams;
+
+			h_data = new VLCHolderWnd(hWnd, p_instance);
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(h_data));
+			
+			RECT ParentClientRect;
+			GetClientRect(CreateStruct->hwndParent, &ParentClientRect);
+			MoveWindow(hWnd, 0, 0, (ParentClientRect.right-ParentClientRect.left), (ParentClientRect.bottom-ParentClientRect.top), FALSE);
+			break;
+		}
+		case WM_NCDESTROY:
+			delete h_data;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, 0);
+			break;
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+};
+
+///////////////////////
+//VLCFullScreenWnd
+///////////////////////
+class VLCFullScreenWnd
+{
+public:
+	static void RegisterWndClassName(HINSTANCE hInstance);
+	static void UnRegisterWndClassName();
+	static VLCFullScreenWnd* CreateFSWindow(VLCPlugin* p_instance);
+	void DestroyWindow()
+		{::DestroyWindow(_hWnd);};
+
+
+private:
+	static LPCTSTR getClassName(void) { return TEXT("VLC ActiveX Fullscreen Class"); };
+	static LRESULT CALLBACK FSWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+	static LPCTSTR getControlsClassName(void) { return TEXT("VLC ActiveX Fullscreen Controls Class"); };
+	static LRESULT CALLBACK FSControlsWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+	static HINSTANCE _hinstance;
+    static ATOM _fullscreen_wndclass_atom;
+	static ATOM _fullscreen_controls_wndclass_atom;
+
+private:
+	VLCFullScreenWnd(HWND hWnd, VLCPlugin* p_instance)
+		:_hWnd(hWnd), _p_instance(p_instance),
+		 hControlsWnd(0), hToolTipWnd(0), hNewMessageBitmap(0), hFSButtonBitmap(0), hFSButton(0),
+		 hPauseBitmap(0), hPlayBitmap(0), hPlayPauseButton(0), hVideoPosScroll(0),  
+		 hMuteButton(0), hVolumeBitmap(0), hVolumeMutedBitmap(0),
+		 hVolumeSlider(0), Last_WM_MOUSEMOVE_lParam(0){};
+
+	~VLCFullScreenWnd();
+
+private:
+	void RegisterEvents();
+	void UnRegisterEvents();
+
+	void SetVideoPosScrollRangeByVideoLen();
+	void SyncVideoPosScrollPosWithVideoPos();
+	void SetVideoPos(float Pos); //0-start, 1-end
+	//void SetVideoPosByScrollPos(int CurScrollPos);
+	
+	void SyncVolumeSliderWithVLCVolume();
+	void SetVLCVolumeBySliderPos(int CurScrollPos);
+
+	void NeedShowControls();
+	void NeedHideControls();
+
+private:
+	void CreateToolTip();
+
+private:
+	LPARAM Last_WM_MOUSEMOVE_lParam;
+
+private:
+	VLCPlugin* _p_instance;
+	HWND hControlsWnd;
+	HWND hToolTipWnd;
+	
+	HICON hNewMessageBitmap;
+	HANDLE hFSButtonBitmap;
+	HWND hFSButton;
+	
+	HANDLE hPauseBitmap;
+	HANDLE hPlayBitmap; 
+	HWND hPlayPauseButton;
+
+	HWND hVideoPosScroll; 
+	
+	HANDLE hVolumeBitmap;
+	HANDLE hVolumeMutedBitmap;
+	HWND hMuteButton;
+	HWND hVolumeSlider;
+
+private:
+	void SetVideoPosScrollPosByVideoPos(int CurPos);
+	static bool handle_position_changed_event_enabled;
+	static void handle_position_changed_event(const libvlc_event_t* event, void *param);
+	//static void handle_time_changed_event(const libvlc_event_t* event, void *param);
+	static void handle_input_state_event(const libvlc_event_t* event, void *param);
+
+public:
+	HWND getHWND() const {return _hWnd;}
+private:
+	HWND _hWnd;
+	
+	int VideoPosShiftBits;
+};
+
+/////////////////////////////////
+//VLCFullScreenWnd static members
+HINSTANCE VLCFullScreenWnd::_hinstance=0;
+ATOM VLCFullScreenWnd::_fullscreen_wndclass_atom=0;
+ATOM VLCFullScreenWnd::_fullscreen_controls_wndclass_atom=0;
+
+bool VLCFullScreenWnd::handle_position_changed_event_enabled=true;
+void VLCFullScreenWnd::RegisterWndClassName(HINSTANCE hInstance)
+{
+	//save hInstance for future use
+	_hinstance=hInstance;
+
+    WNDCLASS wClass; 
+	
+	memset(&wClass, 0 , sizeof(wClass));
+	if( ! GetClassInfo(_hinstance,  getClassName(), &wClass) )
+    {
+        wClass.style          = CS_NOCLOSE|CS_DBLCLKS;
+        wClass.lpfnWndProc    = FSWndWindowProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getClassName();
+
+        _fullscreen_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _fullscreen_wndclass_atom = 0;
+    }
+	
+	memset(&wClass, 0 , sizeof(wClass));
+	if( ! GetClassInfo(_hinstance,  getControlsClassName(), &wClass) )
+    {
+        wClass.style          = CS_NOCLOSE;
+        wClass.lpfnWndProc    = FSControlsWndWindowProc;
+        wClass.cbClsExtra     = 0;
+        wClass.cbWndExtra     = 0;
+        wClass.hInstance      = _hinstance;
+        wClass.hIcon          = NULL;
+        wClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
+        wClass.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
+        wClass.lpszMenuName   = NULL;
+        wClass.lpszClassName  = getControlsClassName();
+
+        _fullscreen_controls_wndclass_atom = RegisterClass(&wClass);
+    }
+    else
+    {
+        _fullscreen_controls_wndclass_atom = 0;
+    }
+}
+void VLCFullScreenWnd::UnRegisterWndClassName()
+{
+	if(0 != _fullscreen_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_fullscreen_wndclass_atom), _hinstance);
+		_fullscreen_wndclass_atom=0;
+	}
+
+	if(0 != _fullscreen_controls_wndclass_atom){
+		UnregisterClass(MAKEINTATOM(_fullscreen_controls_wndclass_atom), _hinstance);
+		_fullscreen_controls_wndclass_atom=0;
+	}
+}
+
+LRESULT CALLBACK VLCFullScreenWnd::FSWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = fs_data ? fs_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			p_instance = (VLCPlugin*)CreateStruct->lpCreateParams;
+
+			fs_data = new VLCFullScreenWnd(hWnd, p_instance);
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(fs_data));
+			
+			fs_data->hControlsWnd = 
+				CreateWindow(fs_data->getControlsClassName(),
+						TEXT("VLC ActiveX Full Screen Controls Window"),
+						WS_VISIBLE|WS_CHILD|WS_CLIPSIBLINGS, 
+						0, 
+						0, 
+						0, 0,
+						hWnd,
+						0,
+						VLCFullScreenWnd::_hinstance,
+						(LPVOID) fs_data);
+			
+            break;
+		}
+		case WM_NCDESTROY:
+			delete fs_data;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, 0);
+			break;
+		case WM_MOUSEMOVE:{
+			if(fs_data->Last_WM_MOUSEMOVE_lParam!=lParam){
+				fs_data->Last_WM_MOUSEMOVE_lParam=lParam;
+				fs_data->NeedShowControls();
+			}
+			break;
+		}
+		case WM_SHOWWINDOW:{
+			if(FALSE==wParam){ //hidding
+				fs_data->UnRegisterEvents();	
+				break;
+			}
+			else{//showing
+				fs_data->RegisterEvents();	
+			}
+
+			fs_data->NeedShowControls();
+
+			//simulate lParam for WM_SIZE
+			RECT ClientRect;
+			GetClientRect(hWnd, &ClientRect);
+			lParam = MAKELPARAM(ClientRect.right, ClientRect.bottom);
+		}
+		case WM_SIZE:{
+			if(p_instance&&p_instance->getHolderWindow()&&GetParent(p_instance->getHolderWindow()->getHWND())==hWnd){
+				int new_client_width = LOWORD(lParam);
+				int new_client_height = HIWORD(lParam);
+				SetWindowPos(p_instance->getHolderWindow()->getHWND(), HWND_BOTTOM, 0, 0, new_client_width, new_client_height, SWP_NOACTIVATE|SWP_NOOWNERZORDER);
+			}
+			break;
+		}
+		case WM_LBUTTONDBLCLK:{
+			p_instance->toggle_fullscreen();
+			break;
+		}
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+	return 0L;
+};
+
+#define ID_FS_SWITCH_FS 1
+#define ID_FS_PLAY_PAUSE 2
+#define ID_FS_VIDEO_POS_SCROLL 3
+#define ID_FS_MUTE 4
+#define ID_FS_VOLUME 5
+#define ID_FS_LABEL 5
+
+LRESULT CALLBACK VLCFullScreenWnd::FSControlsWndWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	VLCPlugin* p_instance = fs_data ? fs_data->_p_instance : 0;
+
+    switch( uMsg )
+    {
+		case WM_CREATE:{
+			CREATESTRUCT* CreateStruct = (CREATESTRUCT*)(lParam);
+			fs_data = (VLCFullScreenWnd*)CreateStruct->lpCreateParams;
+			p_instance = fs_data->_p_instance;
+			SetWindowLongPtr(hWnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(fs_data));
+			
+			fs_data->hNewMessageBitmap = (HICON)
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(8), 
+			              IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+
+			const int ControlsHeigth = 21+2;
+			const int ButtonsWidth = ControlsHeigth;
+			const int ControlsSpace = 5;
+			const int ScrollVOffset = (ControlsHeigth-GetSystemMetrics(SM_CXHSCROLL))/2;
+
+			int HorizontalOffset=ControlsSpace;
+			int ControlWidth=ButtonsWidth;
+			fs_data->hFSButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("End Full Screen"), WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_FLAT, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_SWITCH_FS, 0, 0);
+			fs_data->hFSButtonBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(3), 
+			              IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hFSButtonBitmap);  
+			//SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hNewMessageBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			
+			ControlWidth=ButtonsWidth;
+			fs_data->hPlayPauseButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("Play/Pause"), WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_FLAT, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_PLAY_PAUSE, 0, 0);
+			fs_data->hPlayBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(4), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			fs_data->hPauseBitmap = 
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(5), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS);
+			SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPauseBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+
+			ControlWidth=200;
+			int VideoPosControlHeight = 12;
+			fs_data->hVideoPosScroll = 
+				CreateWindow(PROGRESS_CLASS, TEXT("Video Position"), WS_CHILD|WS_DISABLED|WS_VISIBLE|SBS_HORZ|SBS_TOPALIGN|PBS_SMOOTH, 
+				             HorizontalOffset, ControlsSpace+(ControlsHeigth-VideoPosControlHeight)/2, ControlWidth, VideoPosControlHeight, hWnd, (HMENU)ID_FS_VIDEO_POS_SCROLL, 0, 0);
+			HMODULE hThModule = LoadLibrary(TEXT("UxTheme.dll"));
+			if(hThModule){
+				FARPROC proc = GetProcAddress(hThModule, "SetWindowTheme");
+				typedef HRESULT (WINAPI* SetWindowThemeProc)(HWND, LPCWSTR, LPCWSTR);
+				if(proc){
+					//SetWindowTheme(fs_data->hVideoPosScroll, L"", L"");
+					((SetWindowThemeProc)proc)(fs_data->hVideoPosScroll, L"", L"");
+				}
+				FreeLibrary(hThModule);
+			}
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			
+			ControlWidth=ButtonsWidth;
+			fs_data->hMuteButton = 
+				CreateWindow(TEXT("BUTTON"), TEXT("Mute"), WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_PUSHLIKE|BS_BITMAP, //BS_FLAT
+				             HorizontalOffset, ControlsSpace, ControlWidth, ControlsHeigth, hWnd, (HMENU)ID_FS_MUTE, 0, 0);
+			fs_data->hVolumeBitmap =
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(6), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS|LR_SHARED);
+			fs_data->hVolumeMutedBitmap =
+				LoadImage(DllGetModule(), MAKEINTRESOURCE(7), 
+				          IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS|LR_SHARED);
+			SendMessage(fs_data->hMuteButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hVolumeBitmap);  
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+
+			ControlWidth=100;
+			fs_data->hVolumeSlider = 
+				CreateWindow(TRACKBAR_CLASS, TEXT("Volume"), WS_CHILD|WS_VISIBLE|TBS_HORZ|TBS_BOTTOM|TBS_AUTOTICKS, 
+				             HorizontalOffset, ControlsSpace, ControlWidth, 21, hWnd, (HMENU)ID_FS_VOLUME, 0, 0);
+			HorizontalOffset+=ControlWidth+ControlsSpace;
+			SendMessage(fs_data->hVolumeSlider, TBM_SETRANGE, FALSE, (LPARAM) MAKELONG (0, 100));
+			SendMessage(fs_data->hVolumeSlider, TBM_SETTICFREQ, (WPARAM) 10, 0);  
+			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE|SWP_NOOWNERZORDER);
+			
+			int ControlWndWidth = HorizontalOffset;
+			int ControlWndHeigth = ControlsSpace+ControlsHeigth+ControlsSpace;
+			SetWindowPos(hWnd, HWND_TOPMOST, (GetSystemMetrics(SM_CXSCREEN)-ControlWndWidth)/2, 0, 
+			             ControlWndWidth, ControlWndHeigth, SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_NOACTIVATE);
+			
+			//new message blinking timer
+			SetTimer(hWnd, 2, 500, NULL);
+			
+			fs_data->CreateToolTip();
+
+            break;
+		}
+		case WM_MOUSEMOVE:{
+			fs_data->Last_WM_MOUSEMOVE_lParam=lParam;
+			fs_data->NeedShowControls();//not allow close controll window while mouse within
+			break;
+		}
+		case WM_LBUTTONUP:{
+			POINT BtnUpPoint = {LOWORD(lParam), HIWORD(lParam)};
+			RECT VideoPosRect;
+			GetWindowRect(fs_data->hVideoPosScroll, &VideoPosRect);
+			ClientToScreen(hWnd, &BtnUpPoint);
+			if(PtInRect(&VideoPosRect, BtnUpPoint)){
+				fs_data->SetVideoPos(float(BtnUpPoint.x-VideoPosRect.left)/(VideoPosRect.right-VideoPosRect.left));
+			}
+			break;
+		}
+		case WM_TIMER:{
+			switch(wParam){
+				case 1:{
+					POINT MousePoint;
+					GetCursorPos(&MousePoint);
+					RECT ControlWndRect;
+					GetWindowRect(fs_data->hControlsWnd, &ControlWndRect);
+					if(PtInRect(&ControlWndRect, MousePoint)||GetCapture()==fs_data->hVolumeSlider){
+						fs_data->NeedShowControls();//not allow close control window while mouse within
+					}
+					else{
+						fs_data->NeedHideControls();
+					}
+					break;
+				}
+				case 2:{
+					LRESULT lResult = SendMessage(fs_data->hFSButton, BM_GETIMAGE, (WPARAM)IMAGE_BITMAP, 0);  
+					if((HANDLE)lResult == fs_data->hFSButtonBitmap){
+						if(p_instance->getNewMessageFlag()){
+							SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hNewMessageBitmap);  
+							fs_data->NeedShowControls();//not allow close controll window while new message exist
+						}
+					}
+					else{
+						SendMessage(fs_data->hFSButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hFSButtonBitmap);  
+					}
+
+					break;
+				}
+			}
+			break;
+		}
+		case WM_SETCURSOR:{
+			RECT VideoPosRect;
+			GetWindowRect(fs_data->hVideoPosScroll, &VideoPosRect);
+			DWORD dwMsgPos = GetMessagePos();
+			POINT MsgPosPoint = {LOWORD(dwMsgPos), HIWORD(dwMsgPos)};
+			if(PtInRect(&VideoPosRect, MsgPosPoint)){
+				SetCursor(LoadCursor(NULL, IDC_HAND));
+				return TRUE;
+			}
+			else{
+				return DefWindowProc(hWnd, uMsg, wParam, lParam);
+			}
+			break;
+		}
+		case WM_NCDESTROY:
+			break;
+		case WM_COMMAND:{
+			WORD NCode = HIWORD(wParam);
+			WORD Control = LOWORD(wParam);
+			switch(NCode){
+				case BN_CLICKED:{
+					switch(Control){
+						case ID_FS_SWITCH_FS:	
+							p_instance->toggle_fullscreen();
+							break;
+						case ID_FS_PLAY_PAUSE:
+							if(p_instance->playlist_isplaying()){
+								p_instance->playlist_pause();
+							}
+							else{
+								p_instance->playlist_play();
+							}
+							break;
+						case ID_FS_MUTE:{
+							libvlc_media_player_t* p_md = getMD(p_instance);
+							if( p_md ){
+								libvlc_audio_set_mute(p_md, IsDlgButtonChecked(hWnd, ID_FS_MUTE));
+								fs_data->SyncVolumeSliderWithVLCVolume();
+							}
+							break;
+						}
+					}
+					break;
+				}
+			}
+			break;
+		}
+		case WM_HSCROLL: 
+		case WM_VSCROLL: {
+			libvlc_media_player_t* p_md = getMD(p_instance);
+			if( p_md ){
+				if(fs_data->hVolumeSlider==(HWND)lParam){
+					LRESULT SliderPos=SendMessage(fs_data->hVolumeSlider, (UINT) TBM_GETPOS, 0, 0);  
+					fs_data->SetVLCVolumeBySliderPos(SliderPos);
+				}
+			}
+			break;
+		}
+        default:
+            return DefWindowProc(hWnd, uMsg, wParam, lParam);
+    }
+	return 0L;
+};
+
+VLCFullScreenWnd* VLCFullScreenWnd::CreateFSWindow(VLCPlugin* p_instance)
+{
+	HWND hWnd = CreateWindow(getClassName(),
+				TEXT("VLC ActiveX Full Screen Window"),
+				WS_POPUP|WS_CLIPCHILDREN, 
+				0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
+				0,
+				0,
+				VLCFullScreenWnd::_hinstance,
+				(LPVOID) p_instance
+			   );
+	if(hWnd)
+		return reinterpret_cast<VLCFullScreenWnd*>(GetWindowLongPtr(hWnd, GWLP_USERDATA));
+	
+	return 0;
+}
+
+/////////////////////////////////////
+//VLCFullScreenWnd members
+VLCFullScreenWnd::~VLCFullScreenWnd()
+{
+	if(hToolTipWnd){
+		::DestroyWindow(hToolTipWnd);
+		hToolTipWnd=0;
+	}
+
+	DestroyIcon(hNewMessageBitmap);
+	hNewMessageBitmap=0;
+	DeleteObject(hFSButtonBitmap); 
+	hFSButtonBitmap=0;
+
+	DeleteObject(hPauseBitmap); 
+	hPauseBitmap = 0;
+	DeleteObject(hPlayBitmap);
+	hPlayBitmap = 0;
+
+	DeleteObject(hVolumeBitmap);
+	hVolumeBitmap=0;
+	DeleteObject(hVolumeMutedBitmap);
+	hVolumeMutedBitmap=0;
+}
+
+void VLCFullScreenWnd::NeedShowControls()
+{
+	if(!IsWindowVisible(hControlsWnd)){
+		libvlc_media_player_t* p_md = getMD(_p_instance);
+		if( p_md ){
+			if(hVideoPosScroll){
+				SetVideoPosScrollRangeByVideoLen();
+				SyncVideoPosScrollPosWithVideoPos();
+			}
+			if(hVolumeSlider){
+				SyncVolumeSliderWithVLCVolume();
+			}
+			if(hPlayPauseButton){
+				SendMessage(hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(_p_instance->playlist_isplaying()?hPauseBitmap:hPlayBitmap));  
+			}
+		}
+		ShowWindow(hControlsWnd, SW_SHOW);
+	}
+	//hide controls after 2 seconds
+	SetTimer(hControlsWnd, 1, 2*1000, NULL);
+}
+
+void VLCFullScreenWnd::NeedHideControls()
+{
+	KillTimer(hControlsWnd, 1);
+	ShowWindow(hControlsWnd, SW_HIDE);
+}
+
+void VLCFullScreenWnd::SyncVideoPosScrollPosWithVideoPos()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_time_t pos = libvlc_media_player_get_time(p_md);
+		SetVideoPosScrollPosByVideoPos(pos);
+	}
+}
+
+void VLCFullScreenWnd::SetVideoPosScrollRangeByVideoLen()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_time_t MaxLen = libvlc_media_player_get_length(p_md);
+		VideoPosShiftBits=0;
+		while(MaxLen>0xffff){
+			MaxLen >>= 1;
+			++VideoPosShiftBits;
+		};
+        SendMessage(hVideoPosScroll, (UINT)PBM_SETRANGE, 0, MAKELPARAM(0, MaxLen));
+	}
+}
+
+void VLCFullScreenWnd::SetVideoPosScrollPosByVideoPos(int CurScrollPos)
+{
+    SendMessage(hVideoPosScroll, (UINT)PBM_SETPOS, (WPARAM) (CurScrollPos >> VideoPosShiftBits), 0);
+}
+
+void VLCFullScreenWnd::SetVideoPos(float Pos) //0-start, 1-end
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_media_player_set_time(p_md, libvlc_media_player_get_length(p_md)*Pos);
+		SyncVideoPosScrollPosWithVideoPos();
+	}
+}
+
+void VLCFullScreenWnd::SyncVolumeSliderWithVLCVolume()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		int vol = libvlc_audio_get_volume(p_md);
+		const LRESULT SliderPos=SendMessage(hVolumeSlider, (UINT) TBM_GETPOS, 0, 0);  
+		if(SliderPos!=vol)
+			SendMessage(hVolumeSlider, (UINT) TBM_SETPOS, (WPARAM) TRUE, (LPARAM) vol);  
+
+		bool muted = libvlc_audio_get_mute(p_md);
+		int MuteButtonState = SendMessage(hMuteButton, (UINT) BM_GETCHECK, 0, 0);  
+		if((muted&&(BST_UNCHECKED==MuteButtonState))||(!muted&&(BST_CHECKED==MuteButtonState))){
+			SendMessage(hMuteButton, BM_SETCHECK, (WPARAM)(muted?BST_CHECKED:BST_UNCHECKED), 0);
+		}
+		LRESULT lResult = SendMessage(hMuteButton, BM_GETIMAGE, (WPARAM)IMAGE_BITMAP, 0);  
+		if( (muted && ((HANDLE)lResult == hVolumeBitmap)) || (!muted&&((HANDLE)lResult == hVolumeMutedBitmap)) ){
+			SendMessage(hMuteButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(muted?hVolumeMutedBitmap:hVolumeBitmap));  
+		}
+	}
+}
+
+void VLCFullScreenWnd::SetVLCVolumeBySliderPos(int CurPos)
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_audio_set_volume(p_md, CurPos);
+		if(0==CurPos){
+			libvlc_audio_set_mute(p_md, IsDlgButtonChecked(getHWND(), ID_FS_MUTE));
+		}
+		SyncVolumeSliderWithVLCVolume();
+	}
+}
+
+void VLCFullScreenWnd::CreateToolTip()
+{
+	hToolTipWnd = CreateWindowEx(WS_EX_TOPMOST,
+	        TOOLTIPS_CLASS,
+	        NULL,
+	        WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,		
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        CW_USEDEFAULT,
+	        this->getHWND(),
+	        NULL,
+	        _hinstance,
+	        NULL);
+
+	SetWindowPos(hToolTipWnd,
+	        HWND_TOPMOST,
+	        0, 0, 0, 0,
+	        SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
+
+
+	TOOLINFO ti;
+	ti.cbSize = sizeof(TOOLINFO);
+	ti.uFlags = TTF_SUBCLASS|TTF_IDISHWND;
+	ti.hwnd = this->getHWND();
+	ti.hinst = _hinstance;
+
+	TCHAR HintText[100];
+	RECT ActivateTTRect;
+
+	//end fullscreen button tooltip
+	GetWindowRect(this->hFSButton, &ActivateTTRect);
+	GetWindowText(this->hFSButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hFSButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+	
+	//play/pause button tooltip
+	GetWindowRect(this->hPlayPauseButton, &ActivateTTRect);
+	GetWindowText(this->hPlayPauseButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hPlayPauseButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+	
+	//mute button tooltip
+	GetWindowRect(this->hMuteButton, &ActivateTTRect);
+	GetWindowText(this->hMuteButton, HintText, sizeof(HintText));
+	ti.uId = (UINT_PTR)this->hMuteButton;
+	ti.rect = ActivateTTRect;    
+	ti.lpszText = HintText;
+	SendMessage(hToolTipWnd, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);	
+}
+
+/////////////////////////////////////
+//VLCFullScreenWnd event handlers
+void VLCFullScreenWnd::handle_position_changed_event(const libvlc_event_t* event, void *param)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(param);
+	if(fs_data->handle_position_changed_event_enabled)
+		fs_data->SyncVideoPosScrollPosWithVideoPos();
+}
+
+void VLCFullScreenWnd::handle_input_state_event(const libvlc_event_t* event, void *param)
+{
+	VLCFullScreenWnd* fs_data = reinterpret_cast<VLCFullScreenWnd *>(param);
+    switch( event->type )
+    {
+        case libvlc_MediaPlayerNothingSpecial:
+            break;
+        case libvlc_MediaPlayerOpening:
+            break;
+        case libvlc_MediaPlayerBuffering:
+            break;
+        case libvlc_MediaPlayerPlaying:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPauseBitmap);  
+            break;
+        case libvlc_MediaPlayerPaused:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPlayBitmap);  
+            break;
+        case libvlc_MediaPlayerStopped:
+            SendMessage(fs_data->hPlayPauseButton, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)fs_data->hPlayBitmap);  
+            break;
+        case libvlc_MediaPlayerForward:
+            break;
+        case libvlc_MediaPlayerBackward:
+            break;
+        case libvlc_MediaPlayerEndReached:
+            break;
+        case libvlc_MediaPlayerEncounteredError:
+            break;
+    }
+}
+
+void VLCFullScreenWnd::RegisterEvents()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_event_manager_t *eventManager = NULL;
+
+		eventManager = libvlc_media_player_event_manager(p_md);
+		if(eventManager) {
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerNothingSpecial,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerOpening,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerBuffering,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPlaying,
+								VLCFullScreenWnd::handle_input_state_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPaused,
+								VLCFullScreenWnd::handle_input_state_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerStopped,
+								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerForward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerBackward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerEndReached,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerEncounteredError,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerTimeChanged,
+//								VLCFullScreenWnd::handle_time_changed_event, this);
+			libvlc_event_attach(eventManager, libvlc_MediaPlayerPositionChanged,
+			                    VLCFullScreenWnd::handle_position_changed_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerSeekableChanged,
+//								handle_seekable_changed_event, this);
+//			libvlc_event_attach(eventManager, libvlc_MediaPlayerPausableChanged,
+//								handle_pausable_changed_event, this);
+
+		}
+	}
+}
+
+void VLCFullScreenWnd::UnRegisterEvents()
+{
+	libvlc_media_player_t* p_md = getMD(_p_instance);
+	if( p_md ){
+		libvlc_event_manager_t *eventManager = NULL;
+
+		eventManager = libvlc_media_player_event_manager(p_md);
+		if(eventManager) {
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerNothingSpecial,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerOpening,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerBuffering,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+			
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPlaying,
+								handle_input_state_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPaused,
+								handle_input_state_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerStopped,
+								handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerForward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerBackward,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerEndReached,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerEncounteredError,
+//								VLCFullScreenWnd::handle_input_state_event, this);
+
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerTimeChanged,
+//		                        VLCFullScreenWnd::handle_time_changed_event, this);
+			libvlc_event_detach(eventManager, libvlc_MediaPlayerPositionChanged,
+								VLCFullScreenWnd::handle_position_changed_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerSeekableChanged,
+//		                        handle_seekable_changed_event, this);
+//			libvlc_event_detach(eventManager, libvlc_MediaPlayerPausableChanged,
+//		                        handle_pausable_changed_event, this);
+		}
+	}
+}
+
diff --git a/projects/pause.bmp b/projects/pause.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..0b2c0cb5c6609ad1925317b8f49d78476f51adb3
GIT binary patch
literal 1366
zcmaiz+bgV57{;GDnHggS<1|jSod%Ip8dD@~H>gp>&LLqmlSCoP1(H%osJR)*ArTUa
zTNm;la3^=-|Jdt!t(l}<d)4~B=l89(-u13$z2EP^9}A@U%s`n^$*Q|mH^3&}e;MTU
z^`KV0x3?FMkB^w0oyE$^3PPa}*4Njuu&{ukp&_iTtzl|v3iI>xSY2Jk#KZ(PH#f1k
zxQJjdDC@Vjw%~9$ByM+iH@dpIP*hZej*bqA-QM1gvNC1_?C$QuU@#yxHC6b355M1!
z+}vE)Y+q;S@9#%A97aw~4qPr5YHDhbl9GbV%uL~`swx<bM(K<ljYbiPL{LyrAmeRq
zZFqiumVB7s(b18_8yp<O($W%ITU+t*@qw$WD{!xag9E(1y@7d@l$4;cu~B>)85zO!
z^fX>xUhw|@E-?lM1~4}_hmDO5bar;ixY=w*b#*l=D=TIF;o%`nCKD<uD&*+YcDo%`
zt5ulm*mw@^_tPu4+bv!+H8sgR=IilzBp&C}cX~q)*tq_CBYVBx_;_DmA4W$<<NIf1
zWWZvvh^O?IF#~}B_?=9T9v&W$pPw&rc(0saT3RYxTwIL%`}=r393LNp_s?<qJv=;&
z$;nCamVAAEE%VRL&Tx8q3f|BD{yv(Uo3XsSEcMva(*vK+C+q2FUS6K$!hD!J>orzy
ztWBQ1p`k&J9rH8hL1AH`<Vzpv17o$cw8Z`3p1dpGJ;yIEFEKMSgZlb<+5h(T7HMf|
zQg_^+{PgrB^+aYpj*X2;y)icHit)0uvr%4NE?&?tG8^xCdwUyBr&Bm9D@)$#>FM&O
zzpt;a@((bd^Ye4igP0#XJ3H9h+e2+_t<>A+=O=D%Zg6sPg1fsrTwGkpKU!B;C;9U(
z#>dCw>t&PgRiYAc3X1@oR;y-;e{gcL9;Z;_X0v7r#Yst;DHPl7nkf_;jhZPGCnjp9
rP@IsUnL@G4rI|vp$)uS=vBRO6Lb1)JnL@F}qM1VRkMpWe-~XDwudvHR

literal 0
HcmV?d00001

diff --git a/projects/play.bmp b/projects/play.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..44b52d12804ef70d0c26542c3f61af7168968871
GIT binary patch
literal 1366
zcmZ`(+be8g6#vbbJu};!8FSe)<66gkL@vpsNID+e8c*ZoS|pMvL`g`Z@PP6{3b};j
z60aWQKj2N?#Q$-=-x@PVr_QQx@BRDM`qt&Q*0+B}erpg3TY!-IN>R(JmI-#*|7ns}
z?7?rf+S}Xl`1pwN@o_9JE@E(S5Hm9~SY2I3Z*MQAr>C*9vVyU(G0e};qobn(Q&Uq|
zUS7uV@G$1)<}f)qiKV3_%+AhYeSIB$eSPTa>cYs#i1==9Zbp87zQo<y+Jebsg4^x>
zmdyV@tE;P#k&ywrJyt_!XD5b+hLE0~4wuV?^73-=6$k_bmzI{oY&OfH*PWdmY;SKP
zJ3CwSO-)UBett$M6hcc&3l0tr#9w!Jx763r(14GR4_sbeg0YT|kMZ{Q2Ij#UYHDhP
zC)P;LUS3}C{{AjLSTi|TTU$e0Tbt-D77NPC%1}~LBIoz__mPy8grcG%DO%TcaM^4&
z!8}J{9gIh=JRXni@sXOEDqPgo*2*69<z8`dvDoM4<_b6DfWq_Ng}9)gAi)p&+27xv
zi0}9Np=p|MN`9F`BoYDli8%ug4-d%7$`U{1k@kg!g@W_)@^F8D4~N4cVGj=v!TwWE
zzI%FlFgiMl#>PgpwzlHx>PqZSPfu}jasu{eZ*LEEb#+)+Sde*)MxzLa!*ZT{W@cte
zF3g9yb5>b5{d4|UdsS7H#E<hC=O8C1NAmT0y^=3|)z{Z2_+U)-ioGXK7Z(?pn3zCi
zWu^GPy}gCc=ac?0{>{w|o}Qj$o`^Y*0|NsxZ}iQ%qQA7XH0e3HAYZ{?P*P%_H#Rol
zbUFodjw$p-A-}J$uW|>N&)L}-$N}qPy_=hx*xlVlMMZ_o+vn#euCK3gbaaHfyE~kp
zpUWMmp7xB-dmHDIG1N@N1u%SS5aUqIj-gwV|85Wm4TmjmL2U8sR#l9g5xvFYG2Af|
z;^Y)1)|d&gIhmq~39(c4i(=LJ!!mSr)kTai>{EPcn%B?*{9zfoL;XA4Dl9`1tLvnT
fQe{Bw@_s45u+^}ulQ9v!oJ?TPkGN9o|KZ~gL(I@J

literal 0
HcmV?d00001

diff --git a/projects/volume-muted.bmp b/projects/volume-muted.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..5f5582d3da3ab0a566d0644fddad503904cfc97b
GIT binary patch
literal 1334
zcma)*O=weF5XXOs*QC}cdX15YrZ(0hMZ}MqM(9dhRw*bh)P+kI;s*+K5z=B^1T59M
z6pJDXf>|iIcsw4DpyEP;h-49cg{N{AY-5r|ksw#E|NCJZaO1$-IsY?r=KN>o+<gZ!
zOYtOQz*enR1sbBmcZ7V?{x!mPxqGL^;UgEQyq>40Zvt!9BAzI-AvHs+^D#3YW|;qK
zvu%5YQmI63*2el^V?-V^bZ~~A-U`p2%nKK()oa97KEwKCQGQ`zgo~UyeTvFki~h`I
z<*u<|eTAO1a<BYHxh?D;%H3DfS>^p?bNr~Avqt&lJk{_?8iX)e>(M@sgC)JjW^&p&
z$3-UOzb?OvJIE4YNe~UYT9B>7l<E7cof9<vox>b3ArI@`oM8M)oT<zdxqOa2lo@X}
znEGy#8-;3X6GQdSB+P5do+Eoyrf{2*;!*s&zZ{0^4h7SZ*MYuo3>R*Z2>cM!ftymr
zE23Ex$0#IHem$>P#*p|XylE*U{+~V}@%Q7k<d(OikEE*lhGY|zTqt=b9aelnHixC5
zH?&f9zWg@xu=Yn6`qK=R75_!?{)wmZ?vw_%^S@rwPMX5%hxR*)2Z+?CS!-s5@?vvV
z))bpT4>PFz4K?l;fvYwcUtq7_?`=EgXci32%-=d5V%k}QqqdDnbJBZ#CvXbWjAb&K
zN1nmkN;?Uq0Y80O4N(|lQkPF_M4UdVA6Ws-Gpqih{+3d*l4X}rcNZlT@Fn1D6IT7B
z3v`Wsu+=j&@7HHMC}K}W^<I=v`K!;1+=xUO?@D?1-=ApVG!8Ll_Iuc2zxdUqrpNPM
zs42Tge0$|T#%_vqiQqnbf~`&ZJ2kLG(62dB)$fbC<Bpy+h6=P*py?O*{A!Vi5v6Od
z&u8<)5sXRs2jo}3aNe`T(F<{UrN==05q|>ygJ(3KM~nT8{edKt$@ZvZGTx2_T`aD8
z>oLW~T@2~87{pv84Bg#ZI=kT)PItQ!UBs&dm!}qRZ>R8z2thvg{OTT^cW?0XZ;VD<
R=xr?C?{Bp8Yp4GE`X{Cq0lEMH

literal 0
HcmV?d00001

diff --git a/projects/volume.bmp b/projects/volume.bmp
new file mode 100644
index 0000000000000000000000000000000000000000..8bad9db2cd9404453fcb17c9ebab6e473ad5d88e
GIT binary patch
literal 1334
zcma)*O=uHQ5XXN>*R)Cz*`|?*v|>w<AmT?&BlIL5TPY|WtcM;wh#x4_Lr9DD5U^D1
zQ7kQ@Aee(f4<aH##e)P9$suaNDyyK4Ne)GVtgiq4XswFSfqAq4H}mHGXXfqx{^S}w
zNgA+CUmF4q(d0WqzFD~%;hWsNQReWGa}-}K(wP{?`eG4{71-Q1NAtQ_=041^_|0bf
zjw1Pdp7IwP>w}FEnWgXG9GzW7o<3d_&QY$EX<q*n>yt&{xrGtVapL3&if=5slNXh{
z%;rr+I=3qK`iIJGVgFR_L|JE*_mj=Bqi)VJg%^vI!pEr+!lc!seHI5xdW8<s+Bw5{
z#^t{%zl)nl5uqW7hTU~YRbbNe{iSu|R39y1_Lz`?jjx9oyA)+IIY~N`W-kTCYE>qG
zn50LbRNq2h<uft!in6Ck9hJ$>kXJm4pTF-gP;tnbj=T;ezB7=WCKmXiSqH956|aa|
zP8=H{*5=pqlC|`SZ_JyPLZWZAgv8&E*C*57juuHt_4Ucd$h%N7FC9>PRyK{Lp;z^#
z>U{ZU=3(uREcd4tDk%P|;{6j(<lQ9=Zs(m|(k^Pk>WB85a{WXqQ?!~%p^Vs^mNmtu
z*TeKGe^rfJB5>IT<16g*`@MbV0=2AxnS7w*A*P%b9JOs!nwH*54B=#_7)>TMj|{yt
zN;?7h9zXq7HAG>IN?ktnVR8DXexw96&y@O$`kQZ)m8`vhy8Bx~0bc^XHeuC2vP{?L
z23tKdGk$%>ogDT=quz@WDu3x&j%$%d#@gGw`)`leajJ(HHM>3Ra6tSjQq$vkD^!!+
zE52Rw53+|G?IO4zpJ089{!R@n7W8XDRQ3C!?zp3;#ZZB^3N-x!pIy!oF&b&#=kw{f
zJB%?Qe~<j?7tVVc9K8^yOF9VRkN6Yt?>(jY-22_n=2b{M9$y(1k4JqRtnsLeUEmsd
lJ?sHtp=GSSCG4O0KVC}scRu%qmG`-~{>jJPaLKGregVU_0tx^C

literal 0
HcmV?d00001

-- 
1.7.4.msysgit.0

